#include <windows.h>
#include <Windowsx.h> // GET_X_LPARAM / GET_Y_LPARAM
#include <d3d11_1.h>
#include <directxmath.h>
#include <mmreg.h>
#include <msacm.h>
#include <string.h>
#include <stdio.h>
#include <lua.hpp>
#include <lauxlib.h>
#include <lualib.h>
using namespace DirectX;
#include "DXCommon.h"
#include "PMDXWork.h"
#include "LMCHand.h"
#include "vmd.h"
#include "VMDWork.h"
#include "UIPanels.h"
#include "LuaAudio.h"

lua_State *gpLua = nullptr;
tWavePlay gWavePlay;

// MikuMikuTickle.c
int IsTickled(int idArea);
XMVECTOR GetMouthPos(XMMATRIX *nowRollPitchYawPos);
extern float g_reaction_tkl_time;
extern float g_reaction_tkl_lv;
extern int g_reaction_nt_face;
extern int g_reaction_nt_speak;
extern int g_reaction_nt_dirhead;
extern int g_reaction_breathing;
extern float g_reaction_breath_time;
extern XMFLOAT3 g_reaction_nt_dirHeadPos;
extern int g_reactreq_nt_face;
extern int g_reactreq_nt_speak;
extern int g_reactreq_nt_dirhead;
extern char *g_aTouchAreaName[NUM_OF_TOUCHAREA];
extern TouchArea g_aTouchArea[NUM_OF_TOUCHAREA];
extern float g_fTouchValTotal;
extern float g_afTouchValArea[NUM_OF_TOUCHAREA];
extern XMFLOAT3 g_avTouchCenter[NUM_OF_TOUCHAREA];
extern XMMATRIX g_nowRollPitchYawPos;
extern char *g_aTklHandName[NUM_OF_TKLHAND];
extern int g_tkl_hand_active[NUM_OF_TKLHAND];
extern t_PmdxWork g_PmdxWork;
extern LMCHand *g_listLMCHand;
extern XMMATRIX g_mWorldLMC;
extern XMFLOAT3 g_InitEyePos;
extern XMFLOAT3 g_EyePos;
extern float g_InitEyeBaseYaw;
extern float g_EyeBaseYaw;

// ֘A֐Q

int ReadBytesAsInt(FILE *f,int nByte,int *err){
  unsigned char buf[4];
  if(fread(buf,sizeof(char),nByte,f)<nByte){
    (*err)=1;
  }
  int iRtn=0;
  for(int i=0;i<nByte;i++){
    iRtn<<=8;
    iRtn|=buf[nByte-1-i];
  }
  return iRtn;
}

short *CreateSamplesByFile(FILE *f, int nBytes, int nChannels, int wavBitsPerSample,
                           int nSamplesPerSec, int nSamples){
  int err=0;
  int wavBytesPerSample=wavBitsPerSample/8;
  short *samples=new short[nSamples];
  for(int i=0;i<nSamples;i++){
    int sampleInt=(short)ReadBytesAsInt(f,wavBytesPerSample,&err);
    if(wavBytesPerSample==1){
      sampleInt=((sampleInt-128)/128.0)*0x7fff;
    }
    samples[i] = (short)sampleInt;
    if(nChannels>1) fseek(f,(nChannels-1)*wavBytesPerSample,SEEK_CUR);
  }
  return samples;
}

tWaveData *CreateWaveDataFromFile(char *filepath){
  tWaveData *pWaveData=nullptr;
  int nChannels=0;
  int err=0;
  int posDChunkExp=0;
  FILE *f;
  if((f=fopen(filepath,"rb"))==nullptr) err=1;
  else{
    char buf[4];
    if(fread(buf,1,4,f)<=0) err=1;
    if(strncmp(buf,"RIFF",4)!=0) err=1;
    if(err==0){
      fseek(f,4,SEEK_CUR); // ȍ~̃oCg
      if(fread(buf,1,4,f)<=0) err=1;
      if(strncmp(buf,"WAVE",4)!=0) err=1;
    }
    if(err==0){
      fread(buf,1,4,f);
      if(strncmp(buf,"fmt ",4)!=0) err=1;
      int nChunkSize=ReadBytesAsInt(f,4,&err);
      posDChunkExp=ftell(f)+nChunkSize;
      int fmtId=ReadBytesAsInt(f,2,&err);
      if(fmtId!=1) err=1;
    }
    if(err==0){
      nChannels=ReadBytesAsInt(f,2,&err);
      if(nChannels==0) err=1;
    }
    if(err==0){
      int nSamplesPerSec=ReadBytesAsInt(f,4,&err);
      int nSpeed=ReadBytesAsInt(f,4,&err); // f[^x
      int szBl=ReadBytesAsInt(f,2,&err); // ubNTCY
      int wavBitsPerSample=ReadBytesAsInt(f,2,&err);
      int nSkip=posDChunkExp-ftell(f);
      if(nSkip>0) fseek(f,nSkip,SEEK_CUR);
      // f[^`NT
      int found=0;
      while((!found)&&(err==0)){
        if(fread(buf,1,4,f)<=0) err=1;
        if(strncmp(buf,"data",4)==0) found=1;
        nSkip=ReadBytesAsInt(f,4,&err);
        if(!found){
          fseek(f,nSkip,SEEK_CUR);
        }
      }
      int iSeekBegin=ftell(f);
      fseek(f,0,SEEK_END);
      int iSeekEnd=ftell(f);
      fseek(f,iSeekBegin,SEEK_SET);
      int nBytes=iSeekEnd-iSeekBegin;
      int nBlockAlign = nChannels * wavBitsPerSample / 8;
      int nSamples=nBytes/nBlockAlign;
      short *samples=CreateSamplesByFile(f, nBytes, nChannels, wavBitsPerSample,
                                         nSamplesPerSec, nSamples);
      pWaveData = new tWaveData;
      pWaveData->nSamples=nSamples;
      pWaveData->nSamplesPerSec=nSamplesPerSec;
      pWaveData->samples=samples;
    }
    fclose(f);
  }
  return pWaveData;
}

int MemBytesAsInt(unsigned char *buf,int nByte){
  int iRtn=0;
  for(int i=0;i<nByte;i++){
    iRtn<<=8;
    iRtn|=buf[nByte-1-i];
  }
  return iRtn;
}

short *CreateSamplesByMemory(unsigned char *waveDataRaw,
                             int nBytes, int nChannels, int wavBitsPerSample,
                             int nSamplesPerSec, int nSamples){
  int err=0;
  unsigned char *dataPtr=waveDataRaw;
  int wavBytesPerSample=wavBitsPerSample/8;
  short *samples=new short[nSamples];
  for(int i=0;i<nSamples;i++){
    int sampleInt=(short)MemBytesAsInt(dataPtr,wavBytesPerSample);
    if(wavBytesPerSample==1){
      sampleInt=((sampleInt-128)/128.0)*0x7fff;
    }
    samples[i] = (short)sampleInt;
    dataPtr+=(nChannels*wavBytesPerSample);
  }
  return samples;
}

tWaveData *CreateWaveDataFromMP3File(char *filepath){
  tWaveData *pWaveData=nullptr;
  int nChannels=0;
  int err=0;
  FILE *f;
  if((f=fopen(filepath,"rb"))==nullptr) err=1;
  else{
    DWORD waveDataSize;
    unsigned char buf[10];
    // ID3v2^O`FbN
    size_t startPos=0;
    ZeroMemory(buf,sizeof(buf));
    fread(buf,1,10,f);
    if(strncmp((char *)buf,"ID3",3)==0){
      DWORD nTagSize = 0;
      for(int i=0; i<4; i++){
        nTagSize*=128;
        nTagSize += buf[6+i]&0x7f;
      }
      if(buf[5]&0x10) nTagSize+=10;
      startPos=10+nTagSize;
    }
    // ID3v1^O`FbN
    size_t endPos=0;
    fseek(f,-128,SEEK_END);
    ZeroMemory(buf,sizeof(buf));
    fread(buf,1,3,f);
    if(strncmp((char *)buf,"TAG",3)==0) endPos=ftell(f)-3;
    else endPos=ftell(f)-3+128;
    // ǂݍ݈ʒuf[^Jnʒuɖ߂
    fseek(f,startPos,SEEK_SET);
    // t[wb_ǂݍ
    ZeroMemory(buf,sizeof(buf));
    fread(buf,1,4,f);
    if((buf[0]!=255)||((buf[1]&0xe0)!=0xe0)) err=1;
    else{
      int versionCode = (buf[1]&0x18)>>3;
      int layerCode = (buf[1]&6)>>1;
      int bitrateCode = (buf[2]&0xf0)>>4;
      int samplingRateCode = (buf[2]&0x0c)>>2;
      int padding = (buf[2]&2)>>1;
      int channelMode = (buf[3]&0xc0)>>6;
      int bitrate = 0;
      if((bitrateCode>=1)&&(bitrateCode<=14)){
        if(versionCode == 3){ // MPEG o[W 1
          if(layerCode==3){ // C[I
            int aBitRate[]={32, 64, 96, 128, 160, 192, 224, 256,
                            288, 320, 352, 384, 416, 448};
            bitrate = aBitRate[bitrateCode-1];
          } else if(layerCode==2){ // C[II
            int aBitRate[]={32, 48, 56, 64, 80, 96, 112, 128,
                            160, 192, 224, 256, 320, 384};
            bitrate = aBitRate[bitrateCode-1];
          } else if(layerCode==1){ // C[III
            int aBitRate[]={32, 40, 48, 56, 64, 80, 96, 112,
                            128, 160, 192, 224, 256, 320};
            bitrate = aBitRate[bitrateCode-1];
          }
        } else if((versionCode==2)||(versionCode==0)) { // MPEG o[W 2/2.5
          if(layerCode==3){ // C[I
            int aBitRate[]={32, 48, 56, 64, 80, 96, 112, 128, 
                            144, 160, 176, 192, 224, 256};
            bitrate = aBitRate[bitrateCode-1];
          } else if(layerCode==2){ // C[II
            int aBitRate[]={8, 16, 24, 32, 40, 48, 56, 64,
                            80, 96, 112, 128, 144, 160};
            bitrate = aBitRate[bitrateCode-1];
          } else if(layerCode==1){ // C[III
            int aBitRate[]={8, 16, 24, 32, 40, 48, 56, 64,
                            80, 96, 112, 128, 144, 160};
            bitrate = aBitRate[bitrateCode-1];
          }
        }
      }
      int samplingRate = 0;
      if(samplingRateCode<3){
        if(versionCode == 3){ // MPEG o[W 1
          int aSamplingRate[]={44100, 48000, 32000};
          samplingRate=aSamplingRate[samplingRateCode-1];
        } else if(versionCode==2){ // MPEG o[W 2
          int aSamplingRate[]={22050, 24000, 16000};
          samplingRate=aSamplingRate[samplingRateCode-1];
        } else if(versionCode==0){ // MPEG o[W 2.5
          int aSamplingRate[]={11025, 12000, 8000};
          samplingRate=aSamplingRate[samplingRateCode-1];
        }
      }
      MPEGLAYER3WAVEFORMAT mp3Format;
      ZeroMemory(&mp3Format, sizeof(mp3Format));
      mp3Format.wfx.wFormatTag = WAVE_FORMAT_MPEGLAYER3;
      mp3Format.wfx.nChannels = ((channelMode == 3)?1:2);
      mp3Format.wfx.nSamplesPerSec = samplingRate;
      mp3Format.wfx.nAvgBytesPerSec = (bitrate * 1000) / 8;
      mp3Format.wfx.nBlockAlign = 1;
      mp3Format.wfx.wBitsPerSample = 0;
      mp3Format.wfx.cbSize = MPEGLAYER3_WFX_EXTRA_BYTES;
      mp3Format.wID = MPEGLAYER3_ID_MPEG;
      mp3Format.fdwFlags = (padding ? MPEGLAYER3_FLAG_PADDING_ISO : MPEGLAYER3_FLAG_PADDING_OFF);
      if(layerCode==3){ // C[I
        mp3Format.nBlockSize = (12 * bitrate / samplingRate + padding) * 4;
      } else if((layerCode==1)&&((versionCode==2)||(versionCode==0))){
        // C[III && (MPEG o[W 2 or 2.5)
        mp3Format.nBlockSize = 72 * bitrate / samplingRate + padding;
      } else{
        mp3Format.nBlockSize = 144 * bitrate / samplingRate + padding;
      }
      mp3Format.nFramesPerBlock = 1;
      mp3Format.nCodecDelay = 0;
      fseek(f,startPos,SEEK_SET);
      size_t mp3DataSize=endPos-startPos;
      unsigned char *mp3Data = new unsigned char[mp3DataSize];
      fread(mp3Data, 1, mp3DataSize, f);

      WAVEFORMATEX wfe;
      ZeroMemory(&wfe, sizeof(wfe));
      wfe.wFormatTag = WAVE_FORMAT_PCM;
      wfe.nChannels = 1;
      wfe.nSamplesPerSec = 44100;
      wfe.wBitsPerSample = 16;
      wfe.nBlockAlign = wfe.nChannels * wfe.wBitsPerSample / 8;
      wfe.cbSize = 0;
      acmFormatSuggest(NULL, &mp3Format.wfx, &wfe, 
                       sizeof(WAVEFORMATEX), ACM_FORMATSUGGESTF_WFORMATTAG);
      HACMSTREAM hACM;
      acmStreamOpen(&hACM, NULL, &mp3Format.wfx, &wfe, NULL, 0, 0, ACM_STREAMOPENF_NONREALTIME);
      DWORD waveDataSize=0;
      acmStreamSize(hACM, mp3DataSize, &waveDataSize, ACM_STREAMSIZEF_SOURCE);
      unsigned char *waveDataRaw = new unsigned char[waveDataSize];
      ACMSTREAMHEADER acmStreamHeader;
      ZeroMemory(&acmStreamHeader, sizeof(acmStreamHeader));
      acmStreamHeader.cbStruct = sizeof(acmStreamHeader);
      acmStreamHeader.cbSrcLength = mp3DataSize;
      acmStreamHeader.pbSrc = mp3Data;
      acmStreamHeader.cbDstLength = waveDataSize;
      acmStreamHeader.pbDst = waveDataRaw;
      acmStreamPrepareHeader(hACM ,&acmStreamHeader, 0);
      acmStreamConvert(hACM, &acmStreamHeader, ACM_STREAMCONVERTF_BLOCKALIGN);
      acmStreamUnprepareHeader(hACM, &acmStreamHeader, 0);
      int nBytes = acmStreamHeader.cbDstLengthUsed;
      int nChannels=wfe.nChannels;
      int wavBitsPerSample=wfe.wBitsPerSample;
      int nSamplesPerSec=wfe.nSamplesPerSec;
      int nBlockAlign = nChannels * wavBitsPerSample / 8;
      int nSamples=nBytes/nBlockAlign;
      short *samples=CreateSamplesByMemory(waveDataRaw, nBytes, nChannels, wavBitsPerSample,
                                           nSamplesPerSec, nSamples);
      pWaveData = new tWaveData;
      pWaveData->nSamples=nSamples;
      pWaveData->nSamplesPerSec=nSamplesPerSec;
      pWaveData->samples=samples;
      acmStreamClose(hACM, 0);
      delete[] mp3Data;
      delete[] waveDataRaw;
    }
    fclose(f);
  }
  return pWaveData;
}

void FinishWaveData(tWaveData *pWaveData){
  delete[] pWaveData->samples;
}

void InitVoice(tVoice *pVoice){
  pVoice->iWaveNow=(-1);
  pVoice->secNow=0.0;
  pVoice->topQuePlay=nullptr;
  pVoice->lastQuePlay=nullptr;
  pVoice->volume=1.0;
}

int AppendWaveData(tWavePlay *pWavePlay, char *filepath){
  tWaveData *pWaveData=CreateWaveDataFromFile(filepath);
  if(pWaveData==nullptr) pWaveData=CreateWaveDataFromMP3File(filepath);
  int iRtn=(-1);
  if(pWaveData!=nullptr){
    pWaveData->volume=1.0;
    int nWaveData2=pWavePlay->nWaveData+1;
    tWaveData **apWaveData2=new tWaveData *[nWaveData2];
    int i;
    for(i=0;i<pWavePlay->nWaveData;i++) apWaveData2[i]=pWavePlay->apWaveData[i];
    apWaveData2[i]=pWaveData;
    delete[] pWavePlay->apWaveData;
    pWavePlay->apWaveData=apWaveData2;
    pWavePlay->nWaveData=nWaveData2;
    iRtn=i;
  }
  return iRtn;
}

void SetVolumeVoice(tWavePlay *pWavePlay, int iVoice, double volume){
  pWavePlay->apVoice[iVoice]->volume=volume;
}

void SetVolumeWave(tWavePlay *pWavePlay, int iWave, double volume){
  pWavePlay->apWaveData[iWave]->volume=volume;
}

void StartVoice(tWavePlay *pWavePlay, int iVoice, int iWave,
                double startSec,double playSec, int flgRepeat){
  if(pWavePlay->nVoice>iVoice){
    tVoice *pVoice=pWavePlay->apVoice[iVoice];
    if(pWavePlay->nWaveData>iWave){
      tQuePlay *pQuePlay=new tQuePlay;
      pQuePlay->next=nullptr;
      pQuePlay->iWave=iWave;
      pQuePlay->secStart=startSec;
      pQuePlay->secPlay=playSec;
      pQuePlay->flgRepeat=flgRepeat;
      if(pVoice->topQuePlay==nullptr) pVoice->topQuePlay=pQuePlay;
      else pVoice->lastQuePlay->next = pQuePlay;
      pVoice->lastQuePlay=pQuePlay;
    }
  }
}

int IsPlayingVoice(tWavePlay *pWavePlay, int iVoice){
  return (pWavePlay->apVoice[iVoice]->topQuePlay!=nullptr);
}

void ShiftQueVoice(tVoice *pVoice){
  tQuePlay *pQuePlay=pVoice->topQuePlay;
  pVoice->topQuePlay=pQuePlay->next;
  if(pVoice->lastQuePlay == pQuePlay) pVoice->lastQuePlay=nullptr;
  delete pQuePlay;
}

void ClearVoiceQue(tVoice *pVoice){
  while(pVoice->topQuePlay){
    ShiftQueVoice(pVoice);
  }
}

void StopVoice(tWavePlay *pWavePlay, int iVoice){
  if(pWavePlay->nVoice>iVoice){
    tVoice *pVoice=pWavePlay->apVoice[iVoice];
    ClearVoiceQue(pVoice);
    pVoice->iWaveNow=(-1);
  }
}

double ForwardVoice(tWavePlay *pWavePlay, int iVoice){
  double delta=1.0/pWavePlay->nSamplesPerSec;
  tVoice *pVoice=pWavePlay->apVoice[iVoice];
  double dRtn=0;
  tQuePlay *pQuePlay=nullptr;
  double r=0.0;
  int ir=0;
  double s=0;
  int valid=false;
  while(!valid){
    pQuePlay=pVoice->topQuePlay;
    if(pQuePlay){
      if(pVoice->iWaveNow!=pQuePlay->iWave){
        pVoice->iWaveNow=pQuePlay->iWave;
        pVoice->secNow=pQuePlay->secStart;
      }
      tWaveData *pWaveData=pWavePlay->apWaveData[pVoice->iWaveNow];
      r=pVoice->secNow * pWaveData->nSamplesPerSec;
      ir=(int)r;
      int flgEnd=0;
      if(pQuePlay->secPlay>=0.0){
        if(pVoice->secNow>=(pQuePlay->secStart+pQuePlay->secPlay)) flgEnd=1;
      } else if(ir>=pWaveData->nSamples) flgEnd=1;
      if(flgEnd){
        if(pQuePlay->flgRepeat){
          pVoice->secNow=pQuePlay->secStart;
          r=pVoice->secNow * pWaveData->nSamplesPerSec;
          ir=(int)r;
          valid=1;
        } else{
          ShiftQueVoice(pVoice);
          pVoice->iWaveNow=(-1);
        }
      } else valid=1;
    } else valid=1;
  }
  if(pQuePlay&&(pVoice->iWaveNow>=0)){
    r-=ir;
    tWaveData *pWaveData=pWavePlay->apWaveData[pVoice->iWaveNow];
    if(ir<pWaveData->nSamples){
      double s0=pWaveData->samples[ir];
      if(ir+1<pWaveData->nSamples){
        double s1=pWaveData->samples[ir+1];
        s=s0+r*(s1-s0);
        s*=pWaveData->volume;
      } else s=s0;
    }
    dRtn=s*(pVoice->volume);
    pVoice->secNow+=delta;
  }
  return dRtn;
}

void InitWavePlay(tWavePlay *pWavePlay){
  WAVEFORMATEX wfe;
  wfe.wFormatTag = WAVE_FORMAT_PCM;
  wfe.nChannels = 1;
  wfe.nSamplesPerSec = 44100;
  wfe.wBitsPerSample = 16;
  wfe.nBlockAlign = wfe.nChannels * wfe.wBitsPerSample / 8;
  wfe.nAvgBytesPerSec = wfe.nSamplesPerSec * wfe.nBlockAlign;
  wfe.cbSize = 0;
  pWavePlay->nSamplesPerSec=wfe.nSamplesPerSec;
  pWavePlay->bufSec=1.0/20;
  pWavePlay->bufSizeShort=(int)(pWavePlay->bufSec*wfe.nAvgBytesPerSec/sizeof(short));
  waveOutOpen(&(pWavePlay->hWave), WAVE_MAPPER, &wfe, 0, 0, CALLBACK_NULL);
  for(int i=0;i<WAVE_BUFFER_COUNT;i++){
    pWavePlay->wWave[i]=new short[pWavePlay->bufSizeShort];
    ZeroMemory(&(pWavePlay->whdr[i]),sizeof(WAVEHDR));
    pWavePlay->whdr[i].lpData=(LPSTR) pWavePlay->wWave[i];
    pWavePlay->whdr[i].dwBufferLength = 0;
    pWavePlay->whdr[i].dwFlags = WHDR_BEGINLOOP | WHDR_ENDLOOP;
    pWavePlay->whdr[i].dwLoops = 1;
    pWavePlay->queIdx[i]=(-1);
    pWavePlay->inQue[i]=0;
  }
  pWavePlay->nVoice=0;
  pWavePlay->apVoice=nullptr;
  pWavePlay->nWaveData=0;
  pWavePlay->apWaveData=nullptr;
}

int AppendVoice(tWavePlay *pWavePlay){
  int nVoice2=pWavePlay->nVoice+1;
  tVoice **apVoice2=new tVoice *[nVoice2];
  int i;
  for(i=0;i<pWavePlay->nVoice;i++) apVoice2[i]=pWavePlay->apVoice[i];
  apVoice2[i]=new tVoice;
  InitVoice(apVoice2[i]);
  delete pWavePlay->apVoice;
  pWavePlay->apVoice=apVoice2;
  pWavePlay->nVoice=nVoice2;
  return i;
}

int GetQueIdxByBufIdx(tWavePlay *pWavePlay, int idxBuf){
  int iRtn=(-1);
  for(int i=0;i<WAVE_BUFFER_COUNT;i++){
    if(pWavePlay->queIdx[i]==idxBuf){
      iRtn=i;
    }
  }
  return iRtn;
}

void EnquePlayBuf(tWavePlay *pWavePlay, int idxBuf){
  pWavePlay->whdr[idxBuf].dwBufferLength=pWavePlay->bufSizeShort*sizeof(short);
  pWavePlay->whdr[idxBuf].dwFlags &= (~WHDR_DONE);
  waveOutPrepareHeader(pWavePlay->hWave , &(pWavePlay->whdr[idxBuf]) , sizeof(WAVEHDR));
  waveOutWrite(pWavePlay->hWave,&(pWavePlay->whdr[idxBuf]),sizeof(WAVEHDR));
  for(int i=0;i<WAVE_BUFFER_COUNT;i++){
    if(pWavePlay->queIdx[i]<0){
      pWavePlay->queIdx[i]=idxBuf;
      break;
    }
  }
  pWavePlay->inQue[idxBuf]=1;
}

void DequePlayCompleteBuf(tWavePlay *pWavePlay){
  while(1){
    int idx=pWavePlay->queIdx[0];
    if((idx<0) || ((pWavePlay->whdr[idx].dwFlags & WHDR_DONE)==0)) break;
    waveOutUnprepareHeader(pWavePlay->hWave , &(pWavePlay->whdr[idx]) , sizeof(WAVEHDR));
    pWavePlay->inQue[idx]=0;
    for(int i=1;i<WAVE_BUFFER_COUNT;i++){
      pWavePlay->queIdx[i-1]=pWavePlay->queIdx[i];
    }
    pWavePlay->queIdx[WAVE_BUFFER_COUNT-1]=(-1);
  }
}

int GetFreeBufIdx(tWavePlay *pWavePlay){
  int idx=(-1);
  for(int i=0;i<WAVE_BUFFER_COUNT;i++){
    if(!(pWavePlay->inQue[i])){
      idx=i;
      break;
    }
  }
  return idx;
}

void ZeroClearBuf(tWavePlay *pWavePlay, int idx){
  for(int i=0;i<pWavePlay->bufSizeShort;i++) pWavePlay->wWave[idx][i]=0;
}

void ForwardWavePlay(tWavePlay *pWavePlay){
  DequePlayCompleteBuf(pWavePlay);
  while(1){
    int idx=GetFreeBufIdx(pWavePlay);
    if(idx<0) break;
    ZeroClearBuf(pWavePlay, idx);
    for(int i=0;i<pWavePlay->bufSizeShort;i++){
      double s=0;
      for(int j=0;j<pWavePlay->nVoice;j++) s+=ForwardVoice(pWavePlay, j);
      pWavePlay->wWave[idx][i]=s;
    }
    EnquePlayBuf(pWavePlay, idx);
  }
}

void FinishWavePlay(tWavePlay *pWavePlay){
  waveOutReset(pWavePlay->hWave);
  for(int i=0;i<WAVE_BUFFER_COUNT;i++){
    waveOutUnprepareHeader((HWAVEOUT)(pWavePlay->hWave),
                           &(pWavePlay->whdr[i]), sizeof(WAVEHDR));
    delete pWavePlay->wWave[i];
  }
  for(int i=0;i<pWavePlay->nVoice;i++){
    delete pWavePlay->apVoice[i];
  }
  delete[] pWavePlay->apVoice;
  for(int i=0;i<pWavePlay->nWaveData;i++){
    FinishWaveData(pWavePlay->apWaveData[i]);
    delete pWavePlay->apWaveData[i];
  }
  delete[] pWavePlay->apWaveData;
  waveOutClose(pWavePlay->hWave);
}

// Lua֘A֐Q
void WriteLuaLog(const char *errstr){
  FILE *logf;
  if((logf=fopen("lualog.txt","a"))!=nullptr){
    fprintf(logf,"%s\n", errstr);
    fclose(logf);
  }
}

int Lua_WriteLuaLog(lua_State *pLua){
  const char *errstr = lua_tostring(pLua, 1);
  WriteLuaLog(errstr);
  return 0;
}

int Lua_AppendVoice(lua_State *pLua){
  lua_pushnumber(pLua, AppendVoice(&gWavePlay));
  return 1;
}

int Lua_AppendWaveData(lua_State *pLua){
  const char *fname = lua_tostring(pLua, 1);
  lua_pushnumber(pLua, AppendWaveData(&gWavePlay, (char *)fname));
  return 1;
}

int Lua_SetVolumeVoice(lua_State *pLua){
  int iVoice = lua_tonumber(pLua, 1);
  char errmsg[100];
  if((iVoice<0)||(iVoice>=gWavePlay.nVoice)){
    sprintf(errmsg,"MMTF.SetVolumeVoice: 1(%d)łB",iVoice);
    WriteLuaLog(errmsg);
  } else{
    double volume = lua_tonumber(pLua, 2);
    SetVolumeVoice(&gWavePlay, iVoice, volume);
  }
  return 0;
}

int Lua_SetVolumeWave(lua_State *pLua){
  int iWave = lua_tonumber(pLua, 1);
  char errmsg[100];
  if((iWave<0)||(iWave>=gWavePlay.nWaveData)){
    sprintf(errmsg,"MMTF.SetVolumeWave: 1(%d)łB",iWave);
    WriteLuaLog(errmsg);
  } else{
    double volume = lua_tonumber(pLua, 2);
    SetVolumeWave(&gWavePlay, iWave, volume);
  }
  return 0;
}

int Lua_StartVoice(lua_State *pLua){
  int iVoice = lua_tonumber(pLua, 1);
  int iWave = lua_tonumber(pLua, 2);
  double startSec = lua_tonumber(pLua, 3);
  double playSec = lua_tonumber(pLua, 4);
  int flgRepeat = lua_toboolean(pLua, 5);
  char errmsg[100];
  if((iVoice<0)||(iVoice>=gWavePlay.nVoice)){
    sprintf(errmsg,"MMTF.StartVoice: 1(%d)łB",iVoice);
    WriteLuaLog(errmsg);
  } else if((iWave<0)||(iWave>=gWavePlay.nWaveData)){
    sprintf(errmsg,"MMTF.StartVoice: 2(%d)łB",iWave);
    WriteLuaLog(errmsg);
  } else{
    StartVoice(&gWavePlay, iVoice, iWave, startSec, playSec, flgRepeat);
  }
  return 0;
}

int Lua_StopVoice(lua_State *pLua){
  int iVoice = lua_tonumber(pLua, 1);
  StopVoice(&gWavePlay, iVoice);
  return 0;
}

int Lua_IsPlayingVoice(lua_State *pLua){
  int iVoice = lua_tonumber(pLua, 1);
  char errmsg[100];
  if((iVoice<0)||(iVoice>=gWavePlay.nVoice)){
    sprintf(errmsg,"SYS_IsPlayingVoice: 1(%d)łB",iVoice);
    WriteLuaLog(errmsg);
    lua_pushboolean(pLua, 0);
  } else{
    lua_pushboolean(pLua, IsPlayingVoice(&gWavePlay, iVoice));
  }
  return 1;
}

int Lua_IsTickled(lua_State *pLua){
  int idArea = lua_tonumber(pLua, 1);
  char errmsg[100];
  if((idArea<(-1))||(idArea>=NUM_OF_TOUCHAREA)){
    sprintf(errmsg,"MMTF.IsTickled: 1(%d)łB",idArea);
    WriteLuaLog(errmsg);
    lua_pushboolean(pLua, 0);
  } else{
    lua_pushboolean(pLua, IsTickled(idArea));
  }
  return 1;
}

int Lua_GetTickleVal(lua_State *pLua){
  int idArea = lua_tonumber(pLua, 1);
  char errmsg[100];
  if((idArea<(-1))||(idArea>=NUM_OF_TOUCHAREA)){
    sprintf(errmsg,"SYS_GetTickleVal: 1(%d)łB",idArea);
    WriteLuaLog(errmsg);
    lua_pushboolean(pLua, 0);
  } else{
    float rtnVal;
    if(idArea<0) rtnVal=g_fTouchValTotal;
    else rtnVal=g_afTouchValArea[idArea];
    lua_pushnumber(pLua, rtnVal);
  }
  return 1;
}

int Lua_ReqReactionNT(lua_State *pLua){
  g_reactreq_nt_face=lua_tonumber(pLua, 1);
  g_reactreq_nt_speak=lua_tonumber(pLua, 2);
  g_reactreq_nt_dirhead=lua_tonumber(pLua, 3);
  return 0;
}

int Lua_GetReactionNT(lua_State *pLua){
  lua_pushnumber(pLua, g_reaction_nt_face);
  lua_pushnumber(pLua, g_reaction_nt_speak);
  lua_pushnumber(pLua, g_reaction_nt_dirhead);
  return 3;
}

int Lua_GetReactionTklTimeLv(lua_State *pLua){
  lua_pushnumber(pLua, g_reaction_tkl_time);
  lua_pushnumber(pLua, g_reaction_tkl_lv);
  return 2;
}

int Lua_IsBreathing(lua_State *pLua){
  lua_pushboolean(pLua, g_reaction_breathing);
  return 1;
}

int Lua_GetReactionBreathTime(lua_State *pLua){
  lua_pushnumber(pLua, g_reaction_breath_time);
  return 1;
}

int Lua_ShowDebugPanel(lua_State *pLua){
  int n=lua_gettop(pLua);
  if(n>1){
    int width = lua_tonumber(pLua, 1);
    const char **msgShow=new const char *[n-1];
    for(int i=2; i<=n; i++){
      msgShow[i-2] = lua_tostring(pLua, i);
    }
    ShowDebugPanel(n-1, msgShow, width);
  }
  return 0;
}

int Lua_HideDebugPanel(lua_State *pLua){
  HideDebugPanel();
  return 0;
}

void GetMatrixFromLua(XMMATRIX *mWork, lua_State *pLua, int idx){
  XMFLOAT4X4 f44Work;
  for(int i=0;i<4;i++){
    for(int j=0;j<4;j++){
      int k=4*i+j+1;
      lua_pushnumber(pLua, k);
      lua_rawget(pLua, idx);
      f44Work.m[i][j] = lua_tonumber(pLua, -1);
      lua_pop(pLua, 1);
    }
  }
  *mWork=XMLoadFloat4x4(&f44Work);
}

void PushMatrixToLua(lua_State *pLua, XMMATRIX *mWork){
  XMFLOAT4X4 f44Work;
  XMStoreFloat4x4(&f44Work,*mWork);
  lua_newtable(pLua);
  for(int i=0;i<4;i++){
    for(int j=0;j<4;j++){
      int k=4*i+j+1;
      lua_pushnumber(pLua, k);
      lua_pushnumber(pLua, f44Work.m[i][j]);
      lua_settable(pLua,-3);
    }
  }
}

int Lua_MatrixMul(lua_State *pLua){
  XMMATRIX mWork1,mWork2;
  GetMatrixFromLua(&mWork1, pLua, 1);
  GetMatrixFromLua(&mWork2, pLua, 2);
  XMMATRIX mWork3=mWork2*mWork1;
  PushMatrixToLua(pLua, &mWork3);
  return 1;
}

int Lua_MatrixInv(lua_State *pLua){
  XMMATRIX mWork1;
  GetMatrixFromLua(&mWork1, pLua, 1);
  XMVECTOR vDet;
  XMMATRIX mWork2=XMMatrixInverse(&vDet, mWork1);
  lua_pushnumber(pLua, XMVectorGetX(vDet));
  PushMatrixToLua(pLua, &mWork2);
  return 2;
}

int Lua_MatrixIdentity(lua_State *pLua){
  XMMATRIX mWork1=XMMatrixIdentity();
  PushMatrixToLua(pLua, &mWork1);
  return 1;
}

int Lua_MatrixRotX(lua_State *pLua){
  float rad = lua_tonumber(pLua, 1);
  XMMATRIX mWork1=XMMatrixRotationX(rad);
  PushMatrixToLua(pLua, &mWork1);
  return 1;
}

int Lua_MatrixRotY(lua_State *pLua){
  float rad = lua_tonumber(pLua, 1);
  XMMATRIX mWork1=XMMatrixRotationY(rad);
  PushMatrixToLua(pLua, &mWork1);
  return 1;
}

int Lua_MatrixRotZ(lua_State *pLua){
  float rad = lua_tonumber(pLua, 1);
  XMMATRIX mWork1=XMMatrixRotationZ(rad);
  PushMatrixToLua(pLua, &mWork1);
  return 1;
}

int Lua_MatrixScaling(lua_State *pLua){
  float sx = lua_tonumber(pLua, 1);
  float sy = lua_tonumber(pLua, 2);
  float sz = lua_tonumber(pLua, 3);
  XMMATRIX mWork1=XMMatrixScaling(sx,sy,sz);
  PushMatrixToLua(pLua, &mWork1);
  return 1;
}

int Lua_MatrixTranslation(lua_State *pLua){
  float px = lua_tonumber(pLua, 1);
  float py = lua_tonumber(pLua, 2);
  float pz = lua_tonumber(pLua, 3);
  XMMATRIX mWork1=XMMatrixTranslation(px,py,pz);
  PushMatrixToLua(pLua, &mWork1);
  return 1;
}

int Lua_GetRXYZFromMatrix(lua_State *pLua){
  XMMATRIX mWork1;
  GetMatrixFromLua(&mWork1, pLua, 1);
  float rx,ry,rz;
  GetRXYZFromXMMatrix(&rx,&ry,&rz,&mWork1);
  lua_pushnumber(pLua, rx);
  lua_pushnumber(pLua, ry);
  lua_pushnumber(pLua, rz);
  return 3;
}

void GetVecFromLua(XMVECTOR *vW, lua_State *pLua, int idx){
  float val[3];
  for(int i=0;i<3;i++){
    lua_pushnumber(pLua, i+1);
    lua_rawget(pLua, idx);
    val[i] = lua_tonumber(pLua, -1);
    lua_pop(pLua, 1);
  }
  *vW=XMVectorSet(val[0],val[1],val[2],0.0f);
}

void PushVecToLua(lua_State *pLua, XMVECTOR *vW){
  lua_newtable(pLua);
  lua_pushnumber(pLua, 1);
  lua_pushnumber(pLua, XMVectorGetX(*vW));
  lua_settable(pLua,-3);
  lua_pushnumber(pLua, 2);
  lua_pushnumber(pLua, XMVectorGetY(*vW));
  lua_settable(pLua,-3);
  lua_pushnumber(pLua, 3);
  lua_pushnumber(pLua, XMVectorGetZ(*vW));
  lua_settable(pLua,-3);
}

int Lua_MatrixTranslationFromVector(lua_State *pLua){
  XMVECTOR vW1;
  GetVecFromLua(&vW1, pLua, 1);
  XMMATRIX mWork1=XMMatrixTranslationFromVector(vW1);
  PushMatrixToLua(pLua, &mWork1);
  return 1;
}

int Lua_SetReactionNTDirHeadPos(lua_State *pLua){
  XMVECTOR vW1;
  GetVecFromLua(&vW1, pLua, 1);
  XMStoreFloat3(&g_reaction_nt_dirHeadPos,vW1);
  return 0;
}

int Lua_ScaledVec(lua_State *pLua){
  float fr = lua_tonumber(pLua, 1);
  XMVECTOR vW1;
  GetVecFromLua(&vW1, pLua, 2);
  vW1*=fr;
  PushVecToLua(pLua, &vW1);
  return 1;
}

int Lua_VecAdd(lua_State *pLua){
  XMVECTOR vW1,vW2;
  GetVecFromLua(&vW1, pLua, 1);
  GetVecFromLua(&vW2, pLua, 2);
  XMVECTOR vW3=vW1+vW2;
  PushVecToLua(pLua, &vW3);
  return 1;
}

int Lua_VecSub(lua_State *pLua){
  XMVECTOR vW1,vW2;
  GetVecFromLua(&vW1, pLua, 1);
  GetVecFromLua(&vW2, pLua, 2);
  XMVECTOR vW3=vW1-vW2;
  PushVecToLua(pLua, &vW3);
  return 1;
}

int Lua_VecDot(lua_State *pLua){
  XMVECTOR vW1,vW2;
  GetVecFromLua(&vW1, pLua, 1);
  GetVecFromLua(&vW2, pLua, 2);
  lua_pushnumber(pLua, XMVectorGetX(XMVector3Dot(vW1,vW2)));
  return 1;
}

int Lua_VecCross(lua_State *pLua){
  XMVECTOR vW1,vW2;
  GetVecFromLua(&vW1, pLua, 1);
  GetVecFromLua(&vW2, pLua, 2);
  XMVECTOR vW3=XMVector3Cross(vW1,vW2);
  PushVecToLua(pLua, &vW3);
  return 1;
}

int Lua_VecLength(lua_State *pLua){
  XMVECTOR vW1;
  GetVecFromLua(&vW1, pLua, 1);
  lua_pushnumber(pLua, XMVectorGetX(XMVector3Length(vW1)));
  return 1;
}

int Lua_VecTransform(lua_State *pLua){
  XMMATRIX mWork1;
  GetMatrixFromLua(&mWork1, pLua, 1);
  XMVECTOR vW1;
  GetVecFromLua(&vW1, pLua, 2);
  XMVECTOR vW2=XMVector3Transform(vW1, mWork1);
  PushVecToLua(pLua, &vW2);
  return 1;
}

int Lua_GetHeadMatrix(lua_State *pLua){
  PushMatrixToLua(pLua, &g_nowRollPitchYawPos);
  return 1;
}

int Lua_GetMouthPos(lua_State *pLua){
  XMVECTOR vPosMouth=GetMouthPos(&g_nowRollPitchYawPos);
  PushVecToLua(pLua,&vPosMouth);
  return 1;
}

int Lua_GetTickleCenter(lua_State *pLua){
  int idArea = lua_tonumber(pLua, 1);
  char errmsg[100];
  if((idArea<0)||(idArea>=NUM_OF_TOUCHAREA)){
    sprintf(errmsg,"MMTF.GetTickleCenter: 1(%d)łB",idArea);
    WriteLuaLog(errmsg);
    XMVECTOR vW=XMVectorSet(0.0f, 0.0f, 0.0f, 0.0f);
    PushVecToLua(pLua,&vW);
  } else{
    XMVECTOR vW=XMLoadFloat3(&(g_avTouchCenter[idArea]));
    PushVecToLua(pLua,&vW);
  }
  return 1;
}

int Lua_GetTouchAreaMatrix(lua_State *pLua){
  int idArea = lua_tonumber(pLua, 1);
  char errmsg[100];
  if((idArea<0)||(idArea>=NUM_OF_TOUCHAREA)){
    sprintf(errmsg,"MMTF.GetTouchAreaMatrix: 1(%d)łB",idArea);
    WriteLuaLog(errmsg);
    XMMATRIX mWork=XMMatrixIdentity();
    PushMatrixToLua(pLua, &mWork);
  } else{
    XMMATRIX mWork=XMLoadFloat4x4(&(g_aTouchArea[idArea].mWorld));
    PushMatrixToLua(pLua, &mWork);
  }
  return 1;
}

int Lua_GetLMCFingerPos(lua_State *pLua){
  lua_newtable(pLua);
  LMCHand *wkLMCHand=g_listLMCHand;
  int cntHand=0;
  while(wkLMCHand){
    if(wkLMCHand->validLeftRight){
      cntHand++;
      lua_pushnumber(pLua, cntHand);
      lua_newtable(pLua);
      for(int i=0;i<5;i++){
        lua_pushnumber(pLua, i+1);
        XMVECTOR vWk1=GetLMCFingerPos(wkLMCHand,&g_mWorldLMC,i);
        PushVecToLua(pLua,&vWk1);
        lua_settable(pLua,-3);
      }
      lua_settable(pLua,-3);
    }
    wkLMCHand=wkLMCHand->next;
  }
  return 1;
}

int Lua_PosIsInTouchArea(lua_State *pLua){
  XMVECTOR vWk1,vWk2;
  GetVecFromLua(&vWk1, pLua, 1);
  int idArea = lua_tonumber(pLua, 2);
  char errmsg[100];
  if((idArea<0)||(idArea>=NUM_OF_TOUCHAREA)){
    sprintf(errmsg,"MMTF.PosIsInTouchArea: 2(%d)łB",idArea);
    WriteLuaLog(errmsg);
    lua_pushboolean(pLua, 0);
  } else{
    XMMATRIX mInv;
    XMVECTOR vDet;
    mInv=XMLoadFloat4x4(&(g_aTouchArea[idArea].mWorld));
    mInv=XMMatrixInverse(&vDet,mInv);
    vWk2=XMVector3Transform(vWk1,mInv);
    float wx=XMVectorGetX(vWk2);
    float wy=XMVectorGetY(vWk2);
    float wz=XMVectorGetZ(vWk2);
    int flgRes=0;
    if((wx>=(-1.0f))&&(wx<=1.0f)&&
       (wy>=(-1.0f))&&(wy<=1.0f)&&
       (wz>=(-1.0f))&&(wz<=1.0f)) flgRes=1;
    lua_pushboolean(pLua, flgRes);
  }
  return 1;
}

int Lua_GetTouchAreaIdxByName(lua_State *pLua){
  const char *areaName=lua_tostring(pLua, 1);
  int idArea=(-1);
  for(int i=0;i<NUM_OF_TOUCHAREA;i++){
    if(strcmp(g_aTouchAreaName[i],areaName)==0){
      idArea=i;
      break;
    }
  }
  lua_pushnumber(pLua, idArea);
  return 1;
}

int Lua_GetTouchAreaNameByIdx(lua_State *pLua){
  int idArea = lua_tonumber(pLua, 1);
  char errmsg[100];
  if((idArea<0)||(idArea>=NUM_OF_TOUCHAREA)){
    sprintf(errmsg,"MMTF.GetTouchAreaNameByIdx: 1(%d)łB",idArea);
    WriteLuaLog(errmsg);
    lua_pushstring(pLua, "");
  } else{
    lua_pushstring(pLua, g_aTouchAreaName[idArea]);
  }
  return 1;
}

int Lua_GetNumOfTouchArea(lua_State *pLua){
  lua_pushnumber(pLua, NUM_OF_TOUCHAREA);
  return 1;
}

int Lua_GetNumOfTklHand(lua_State *pLua){
  lua_pushnumber(pLua, NUM_OF_TKLHAND);
  return 1;
}

int Lua_GetTklHandIdxByName(lua_State *pLua){
  const char *tklhName=lua_tostring(pLua, 1);
  int idTklh=(-1);
  for(int i=0;i<NUM_OF_TKLHAND;i++){
    if(strcmp(g_aTklHandName[i],tklhName)==0){
      idTklh=i;
      break;
    }
  }
  lua_pushnumber(pLua, idTklh);
  return 1;
}

int Lua_GetTklHandNameByIdx(lua_State *pLua){
  int idTklh = lua_tonumber(pLua, 1);
  char errmsg[100];
  if((idTklh<0)||(idTklh>=NUM_OF_TKLHAND)){
    sprintf(errmsg,"MMTF.GetTklHandNameByIdx: 1(%d)łB",idTklh);
    WriteLuaLog(errmsg);
    lua_pushstring(pLua, "");
  } else{
    lua_pushstring(pLua, g_aTklHandName[idTklh]);
  }
  return 1;
}

int Lua_IsTklHandActive(lua_State *pLua){
  int idTklh = lua_tonumber(pLua, 1);
  char errmsg[100];
  if((idTklh<0)||(idTklh>=NUM_OF_TKLHAND)){
    sprintf(errmsg,"MMTF.IsTklHandActive: 1(%d)łB",idTklh);
    WriteLuaLog(errmsg);
    lua_pushboolean(pLua, 0);
  } else{
    lua_pushboolean(pLua, g_tkl_hand_active[idTklh]);
  }
  return 1;
}

int Lua_GetNumOfBone(lua_State *pLua){
  lua_pushnumber(pLua, GetBoneCount(&g_PmdxWork));
  return 1;
}

int Lua_GetBoneIdxByName(lua_State *pLua){
  const char *boneName=lua_tostring(pLua, 1);
  int iBone=search_bone_idx(&g_PmdxWork,(char *)boneName);
  lua_pushnumber(pLua, iBone);
  return 1;
}

int Lua_GetBoneNameByIdx(lua_State *pLua){
  int nBone=GetBoneCount(&g_PmdxWork);
  int iBone = lua_tonumber(pLua, 1);
  char errmsg[100];
  if((iBone<0)||(iBone>=nBone)){
    sprintf(errmsg,"MMTF.GetBoneNameByIdx: 1(%d)łB",iBone);
    WriteLuaLog(errmsg);
    lua_pushstring(pLua, "");
  } else{
    char boneName[100];
    GetBoneNameByIdx(boneName,sizeof(boneName),&g_PmdxWork,iBone);
    lua_pushstring(pLua, boneName);
  }
  return 1;
}

int Lua_GetBoneWorldMatrix(lua_State *pLua){
  int nBone=GetBoneCount(&g_PmdxWork);
  int iBone = lua_tonumber(pLua, 1);
  char errmsg[100];
  if((iBone<0)||(iBone>=nBone)){
    sprintf(errmsg,"MMTF.GetBoneWorldMatrix: 1(%d)łB",iBone);
    WriteLuaLog(errmsg);
    XMMATRIX mWork=XMMatrixIdentity();
    PushMatrixToLua(pLua, &mWork);
  } else{
    XMMATRIX mWork=XMLoadFloat4x4(&(g_PmdxWork.aBoneState[iBone].mWBone));
    PushMatrixToLua(pLua, &mWork);
  }
  return 1;
}

int Lua_GetInitialBonePos(lua_State *pLua){
  int nBone=GetBoneCount(&g_PmdxWork);
  int iBone = lua_tonumber(pLua, 1);
  char errmsg[100];
  if((iBone<0)||(iBone>=nBone)){
    sprintf(errmsg,"MMTF.GetInitialBonePos: 1(%d)łB",iBone);
    WriteLuaLog(errmsg);
    XMVECTOR vW=XMVectorSet(0.0f, 0.0f, 0.0f, 0.0f);
    PushVecToLua(pLua, &vW);
  } else{
    float px,py,pz;
    GetInitialBonePos(&px,&py,&pz,&g_PmdxWork,iBone);
    XMVECTOR vW=XMVectorSet(px, py, pz, 0.0f);
    PushVecToLua(pLua, &vW);
  }
  return 1;
}

int Lua_GetModelName(lua_State *pLua){
  char modelName[100];
  GetModelName(modelName,sizeof(modelName),&g_PmdxWork);
  lua_pushstring(pLua, modelName);
  return 1;
}

int Lua_SetInitialEyeBasePos(lua_State *pLua){
  XMVECTOR vW1;
  GetVecFromLua(&vW1, pLua, 1);
  XMStoreFloat3(&g_InitEyePos,vW1);
  return 0;
}

int Lua_GetEyeBasePos(lua_State *pLua){
  XMVECTOR vW1;
  vW1=XMLoadFloat3(&g_EyePos);
  PushVecToLua(pLua, &vW1);
  return 1;
}

int Lua_SetInitialEyeBaseYaw(lua_State *pLua){
  g_InitEyeBaseYaw = lua_tonumber(pLua, 1);
  return 0;
}

int Lua_GetEyeBaseYaw(lua_State *pLua){
  lua_pushnumber(pLua, g_EyeBaseYaw);
  return 1;
}

void RegisterLuaFunction(lua_State *pLua, int (*luaFunc)(lua_State*), char *funcName){
  lua_pushcfunction(pLua, luaFunc);
  lua_setglobal(pLua, funcName);
}

void LuaAudioInit(char *fname){
  lua_State *pLua = luaL_newstate();
  gpLua = pLua;
  luaL_openlibs(pLua);
  int err=0;

  InitWavePlay(&gWavePlay);

  // ֐n
  static const luaL_Reg MyLibTable[] = {
    {"WriteLuaLog", Lua_WriteLuaLog},
    {"AppendVoice", Lua_AppendVoice},
    {"AppendWaveData", Lua_AppendWaveData},
    {"SetVolumeVoice", Lua_SetVolumeVoice},
    {"SetVolumeWave", Lua_SetVolumeWave},
    {"StartVoice", Lua_StartVoice},
    {"StopVoice", Lua_StopVoice},
    {"IsPlayingVoice", Lua_IsPlayingVoice},
    {"IsTickled", Lua_IsTickled},
    {"GetTickleVal", Lua_GetTickleVal},
    {"ReqReactionNT", Lua_ReqReactionNT},
    {"GetReactionNT", Lua_GetReactionNT},
    {"GetReactionTklTimeLv", Lua_GetReactionTklTimeLv},
    {"IsBreathing", Lua_IsBreathing},
    {"GetReactionBreathTime", Lua_GetReactionBreathTime},
    {"ShowDebugPanel", Lua_ShowDebugPanel},
    {"HideDebugPanel", Lua_HideDebugPanel},
    {"MatrixMul", Lua_MatrixMul},
    {"MatrixInv", Lua_MatrixInv},
    {"MatrixIdentity", Lua_MatrixIdentity},
    {"MatrixRotX", Lua_MatrixRotX},
    {"MatrixRotY", Lua_MatrixRotY},
    {"MatrixRotZ", Lua_MatrixRotZ},
    {"MatrixScaling", Lua_MatrixScaling},
    {"MatrixTranslation", Lua_MatrixTranslation},
    {"MatrixTranslationFromVector", Lua_MatrixTranslationFromVector},
    {"GetRXYZFromMatrix", Lua_GetRXYZFromMatrix},
    {"SetReactionNTDirHeadPos", Lua_SetReactionNTDirHeadPos},
    {"ScaledVec", Lua_ScaledVec},
    {"VecAdd", Lua_VecAdd},
    {"VecSub", Lua_VecSub},
    {"VecDot", Lua_VecDot},
    {"VecCross", Lua_VecCross},
    {"VecLength", Lua_VecLength},
    {"VecTransform", Lua_VecTransform},
    {"GetHeadMatrix", Lua_GetHeadMatrix},
    {"GetMouthPos", Lua_GetMouthPos},
    {"GetTickleCenter", Lua_GetTickleCenter},
    {"GetTouchAreaMatrix", Lua_GetTouchAreaMatrix},
    {"GetLMCFingerPos", Lua_GetLMCFingerPos},
    {"PosIsInTouchArea", Lua_PosIsInTouchArea},
    {"GetTouchAreaIdxByName", Lua_GetTouchAreaIdxByName},
    {"GetTouchAreaNameByIdx", Lua_GetTouchAreaNameByIdx},
    {"GetNumOfTouchArea", Lua_GetNumOfTouchArea},
    {"GetNumOfTklHand", Lua_GetNumOfTklHand},
    {"GetTklHandIdxByName", Lua_GetTklHandIdxByName},
    {"GetTklHandNameByIdx", Lua_GetTklHandNameByIdx},
    {"IsTklHandActive", Lua_IsTklHandActive},
    {"GetNumOfBone", Lua_GetNumOfBone},
    {"GetBoneIdxByName", Lua_GetBoneIdxByName},
    {"GetBoneNameByIdx", Lua_GetBoneNameByIdx},
    {"GetBoneWorldMatrix", Lua_GetBoneWorldMatrix},
    {"GetInitialBonePos", Lua_GetInitialBonePos},
    {"GetModelName", Lua_GetModelName},
    {"SetInitialEyeBasePos", Lua_SetInitialEyeBasePos},
    {"GetEyeBasePos", Lua_GetEyeBasePos},
    {"SetInitialEyeBaseYaw", Lua_SetInitialEyeBaseYaw},
    {"GetEyeBaseYaw", Lua_GetEyeBaseYaw},
    {NULL, NULL}
  };
  luaL_newlib(pLua, MyLibTable);
  lua_setglobal(pLua, "MMTF");

  // ǂݍ
  if(luaL_loadfile(pLua, fname) != 0){
    WriteLuaLog((char *)lua_tostring(pLua, -1));
    err=1;
  }
  if((err==0)&&(lua_pcall(pLua,0,0,0) != 0)){
    WriteLuaLog((char *)lua_tostring(pLua, -1));
    err=1;
  }
  if(err != 0) LuaAudioFinish();
}

void CallLuaAudioOnFrame(){
  lua_State *pLua = gpLua;
  if(pLua!=nullptr){
    lua_getglobal(pLua, "OnFrame");
    int err=0;
    if(lua_pcall(pLua,0,0,0) != 0){
      WriteLuaLog((char *)lua_tostring(pLua, -1));
      err=1;
    }
    if(err != 0) LuaAudioFinish();
    else ForwardWavePlay(&gWavePlay);
  }
}

void LuaAudioFinish(){
  if(gpLua!=nullptr){
    lua_close(gpLua);
    gpLua = nullptr;
    FinishWavePlay(&gWavePlay);
  }
}
