#define WAVE_BUFFER_COUNT 3
#define NUM_OF_TOUCHAREA 14
#define NUM_OF_TKLHAND 4

struct tWaveData{
  int nSamples;
  int nSamplesPerSec;
  double volume;
  short *samples;
};

struct tQuePlay{
  tQuePlay *next;
  int iWave;
  double secStart;
  double secPlay;
  int flgRepeat;
};

struct tVoice{
  int iWaveNow;
  double secNow;
  tQuePlay *topQuePlay,*lastQuePlay;
  double volume;
};

struct tWavePlay{
  HWAVEOUT hWave;
  int nSamplesPerSec;
  double bufSec;
  int bufSizeShort;
  short *wWave[WAVE_BUFFER_COUNT];
  WAVEHDR whdr[WAVE_BUFFER_COUNT];
  int queIdx[WAVE_BUFFER_COUNT];
  int inQue[WAVE_BUFFER_COUNT];
  int nVoice;
  tVoice **apVoice;
  int nWaveData;
  tWaveData **apWaveData;
};

int AppendWaveData(tWavePlay *pWavePlay, char *filepath);
void StartVoice(tWavePlay *pWavePlay, int iVoice, int iWave,
                double startSec,double playSec, int flgRepeat);
int IsPlayingVoice(tWavePlay *pWavePlay, int iVoice);
void StopVoice(tWavePlay *pWavePlay, int iVoice);
void InitWavePlay(tWavePlay *pWavePlay);
int AppendVoice(tWavePlay *pWavePlay);
void ForwardWavePlay(tWavePlay *pWavePlay);
void FinishWavePlay(tWavePlay *pWavePlay);

void LuaAudioInit(char *fname);
void CallLuaAudioOnFrame();
void CallLuaAudioOnFrame();
void LuaAudioFinish();
