// MikuMikuTickle
// PMD/PMXƗp\

struct PMDXVertex{
  XMFLOAT3 Pos;
  XMFLOAT3 Nor;
  XMFLOAT2 Tex;
  DWORD aiBone[4];
  FLOAT afWeight[4];
};

struct t_MngTexture{
  t_MngTexture *next;
  WCHAR TexPath[_MAX_PATH];
  ID3D11ShaderResourceView *pShaderResourceView;
};

struct t_BoneState{
  int iNextSibling;
  int iParent;
  int iFirstChild;
  int flgWValid; // 0: 1:L 2:ŐV
  int flgWork;
  XMFLOAT4X4 mWBone,mLBone;
  XMFLOAT4X4 *mBkLBone;
  XMFLOAT3 vLocInit;
  int flgUsingBkLBone;
  int iBMorph;
};

#define MAX_BONE_ARRAY_SIZE 1024
struct BoneBuf{
  BoneBuf *next;
  int iUsed;
  int isUpdated;
  ID3D11Buffer *pCBuffer;
  XMFLOAT4X4 amWBone[MAX_BONE_ARRAY_SIZE];
};

struct t_BMorph{
  XMFLOAT3 vBMorph;
  XMFLOAT4 qBMorph;
  XMFLOAT4X4 mBkLBone;
  int iBone;
};

struct t_SimBodyNode{
  XMFLOAT3 vPosNow,vPosPrev,vVelocityPrev;
  int flgMove; // 0: 1:
  int nCnct;
  int *aiCnctSimBodyWire;
};

struct t_SimBodyWire{
  int aiNode[2];
  float fLength;
  int iQNext; // -1:XgA-2:L[O
};

struct t_SimBody2Bone{
  int aiNode[3];
  XMFLOAT3 vDirInit; // aiNode[2]<0̎ɐݒ肷n
  int iBone;
  XMFLOAT4X4 mSimBody2Bone;
};

struct t_IKLink{
  int iBone;
  int angle_constrain;
  float l_angle[3],u_angle[3]; // [xyz]
  XMFLOAT4X4 mBkLBone;
};

struct t_IKData{
  int iBoneIK;
  int iBoneTarget;
  int nIteration;
  float radControl;
  int nIKLink;
  t_IKLink *aIKLink;
};

struct t_PmdxWork{
  char PmdxPath[_MAX_PATH];
  int isPMX; // 0:PMDA1:PMX
  void *pmdx_data; // t_pmd_data or t_pmx_data
  float *aMorphRate;
  int nBMorph;
  t_BMorph *aBMorph;
  t_BoneState *aBoneState;
  XMFLOAT4X4 *amRbBoneConv;
  int iRootBoneState;
  BoneBuf *pBoneBuf;
  int iOfsBoneBuf;
  int isVertUpdated;
  PMDXVertex *aVertex;
  ID3D11Buffer* pVertexBuffer;
  ID3D11Buffer* pIndexBuffer;
  t_MngTexture **aMngTexture,**aMngTexSph,**aMngTexSpa;
  int *aiRbW;
  // g̋V~[V֘A
  int nSimBodyNode;
  t_SimBodyNode *aSimBodyNode;
  int nSimBodyWire,iTopSimBodyWire,iLastSimBodyWire;
  t_SimBodyWire *aSimBodyWire;
  int nSimBody2Bone;
  t_SimBody2Bone *aSimBody2Bone;
  // ̃{[]t^ΏۂO
  int nBoneExcludeGive;
  int *aiBoneExcludeGive;
  // IK
  int nIKData;
  t_IKData *aIKData;
};

void wstr2str(char *rtnstr,wchar_t *srcstr,size_t newsize);
void str2wstr(wchar_t *rtnstr,char *srcstr,size_t newsize);
void GetInitialBonePos(float *x1,float *y1,float *z1,t_PmdxWork *pPmdxWork,int iBone);
int GetBoneCount(t_PmdxWork *pPmdxWork);
int GetVertCount(t_PmdxWork *pPmdxWork);
void SetupBoneStateArray(t_PmdxWork *pPmdxWork);
void InvalidateWBone(t_PmdxWork *pPmdxWork,int iBone);
void UpdateLBone(t_PmdxWork *pPmdxWork,int iBone,XMMATRIX *mLBone);
void SetWBone(t_PmdxWork *pPmdxWork,int iBone);
void ValidateWBone(t_PmdxWork *pPmdxWork,int iBone);
void GetRXYZFromXMMatrix(float *rx,float *ry,float *rz,XMMATRIX *mMat);
void GetRXYZFromFMatrix(float *rx,float *ry,float *rz,XMFLOAT4X4 *fMat);
void GiveRotate(t_PmdxWork *pPmdxWork);
void ValidateAllWBone(t_PmdxWork *pPmdxWork);
void SetLastAllWBone(t_PmdxWork *pPmdxWork);
void SetVertDeformInf(t_PmdxWork *pPmdxWork);
void apply_bone_morph(t_PmdxWork *pPmdxWork);
int search_morph_idx(t_PmdxWork *pPmdxWork,char *morph_name);
void set_morph_rate(t_PmdxWork *pPmdxWork,int idx,float new_rate,
                    float maxspeed,float dt);
void cancel_bone_morph(t_PmdxWork *pPmdxWork);
void restore_bone_local(t_PmdxWork *pPmdxWork);
int search_bone_idx(t_PmdxWork *pPmdxWork,char *bone_name);
void GetBoneNameByIdx(char *sBoneName,int iSizeBoneName,t_PmdxWork *pPmdxWork,int iBone);
int BoneCanTranslate(t_PmdxWork *pPmdxWork,int iBone);
void GetModelName(char *sModelName,int iSizeModelName,t_PmdxWork *pPmdxWork);
void AllocSimBody(t_PmdxWork *pPmdxWork,int nSimBodyNode,int nSimBodyWire,int nSimBody2Bone);
void SetBodyNode(t_PmdxWork *pPmdxWork,int iSimBodyNode,float fx,float fy,float fz,int flgMove);
int SetBodyNodeByBoneName(t_PmdxWork *pPmdxWork,int iSimBodyNode,char *BoneName,int flgMove);
void SetBodyWire(t_PmdxWork *pPmdxWork,int iSimBodyWire,int iSimBodyNode0,int iSimBodyNode1);
int SetSimBody2Bone(t_PmdxWork *pPmdxWork,int iSimBody2Bone,
                    int iSimBodyNode0,int iSimBodyNode1,int iSimBodyNode2,char *BoneName);
void GetMatrixSimBody(t_PmdxWork *pPmdxWork,int iSimBody2Bone,XMMATRIX *mSimBody);
void BuildSimBody(t_PmdxWork *pPmdxWork);
void AppendQSimBodyWire(t_PmdxWork *pPmdxWork,int iSimBodyWire);
void UpdateSimBodyNodePos(t_PmdxWork *pPmdxWork,int iSimBodyNode,XMVECTOR vPos);
void ForwardSimBody(t_PmdxWork *pPmdxWork,float dt);
void ApplySimBody2Bone(t_PmdxWork *pPmdxWork);
int IsExcludeIKBone(int iBone,int *aExcludeIKBone,int nExcludeIKBone);
void InitIK(t_PmdxWork *pPmdxWork);
void ApplyIK(t_PmdxWork *pPmdxWork);
void CancelIK(t_PmdxWork *pPmdxWork);
int GetFaceCount(t_PmdxWork *pPmdxWork);
int GetHitPointLineTri(XMVECTOR *vP, XMVECTOR *vPL, XMVECTOR *vVL,
                       XMVECTOR *vTR0, XMVECTOR *vTR1, XMVECTOR *vTR2);
int GetHitPointLinePMDXFace(XMVECTOR *vP, XMVECTOR vPL, XMVECTOR vVL,
                            t_PmdxWork *pPmdxWork, int iFace);
void GetHitPointPMDXFaces(int *existP, XMVECTOR *vPP, int *existN, XMVECTOR *vPN,
                          t_PmdxWork *pPmdxWork, XMVECTOR vP0, XMVECTOR vV, int min0max1);
