// MikuMikuTickle
// VRppl֘A֐
#include <windows.h>
#include <d3d11_1.h>
#include <directxmath.h>
#include <stdio.h>
using namespace DirectX;
#include "DXCommon.h"
#include "PMDXWork.h"
#include "LMCHand.h"
#include "vmd.h"
#include "VMDWork.h"
#include "UIPanels.h"

#define NUM_OF_UI_PANELS 19
ID3D11Buffer *g_pVertexBufferUIPanel=nullptr;
ID3D11Buffer *g_pIndexBufferUIPanel=nullptr;
UIPanel g_aUIPanels[NUM_OF_UI_PANELS];
UIPanel g_ClockPanel;
char g_StrClockTime[30];
float g_UIPanelStTime=0.0f;
int g_UIPanelPage=0;
UIPanel g_DebugPanel;
XMFLOAT3 g_PanelStPos;
LMCHand *g_pActLMCHand;

// }EX֘A
extern float g_VRMousePos_x,g_VRMousePos_y;
extern int g_ui_mouse_down;
extern float g_VRMouseVisibleTime;

// Ώەϐ
extern XMFLOAT3 g_EyeVelocity;
extern float g_EyeSpeed;
extern int g_tkl_hand_active[];
extern float g_EyeBaseYawVelocity;
extern float g_EyeBaseYawSpeed;
extern float g_leg_open_angle;
extern float g_leg_open_v_angle;
extern float g_leg_front_angle;
extern float g_leg_front_v_angle;
extern float g_leg_s_open_front;
extern t_VmdWork g_VmdWork;
extern t_PmdxWork g_PmdxWork;

// DirectX`
extern ID3D11Device *g_pd3dDevice;
extern ID3D11DeviceContext *g_pImmediateContext;
extern ID3D11Buffer *g_pConstantBuffer;
extern ID3D11RasterizerState *g_pRasterizerStateSingleSide;

void DrawFrame(HDC hBmpDC,int tex_width,int tex_height,int ir,int ig,int ib){
  HPEN hPen=CreatePen(PS_SOLID,2,RGB(ir,ig,ib));
  HPEN hPenOld=(HPEN)SelectObject(hBmpDC,hPen);
  MoveToEx(hBmpDC,0,0,nullptr);
  LineTo(hBmpDC,0,tex_height);
  LineTo(hBmpDC,tex_width,tex_height);
  LineTo(hBmpDC,tex_width,0);
  LineTo(hBmpDC,0,0);
  SelectObject(hBmpDC,hPenOld);
  DeleteObject(hPen);
}

// rbg}bv`揀
void PrepareBitmapDrawing(unsigned char **pBmp, HBITMAP *hBmp, HDC *hBmpDC, HBITMAP *hBmpOld,
                          int tex_width, int tex_height){
  // BMP쐬
  BITMAPINFO bmpInfo = {};
  bmpInfo.bmiHeader.biSize = sizeof(BITMAPINFOHEADER);
  bmpInfo.bmiHeader.biWidth = tex_width;
  bmpInfo.bmiHeader.biHeight = -tex_height;
  bmpInfo.bmiHeader.biPlanes = 1;
  bmpInfo.bmiHeader.biBitCount = 24;
  // DIBSection̍쐬
  *pBmp = nullptr;
  *hBmp = CreateDIBSection(0, &bmpInfo, DIB_RGB_COLORS, (void**)pBmp, 0, 0);
  // Rp`uDC쐬
  HDC hDC = GetDC(NULL);
  *hBmpDC = CreateCompatibleDC(hDC);
  ReleaseDC(NULL, hDC);
  // Rp`uDC̕`DIBSectionw
  *hBmpOld = (HBITMAP)SelectObject(*hBmpDC, *hBmp);
}

// rbg}bvVF[_[\[Xr[쐬
void CreateSRVFromBitmap(ID3D11ShaderResourceView **pShaderResourceView,
                         unsigned char *pBmp, int tex_width, int tex_height){
  // eNX`yу\[Xr[̍쐬
  D3D11_TEXTURE2D_DESC descTx;
  ZeroMemory( &descTx, sizeof(descTx) );
  descTx.Width = tex_width;
  descTx.Height = tex_height;
  descTx.MipLevels = 1;
  descTx.ArraySize = 1;
  descTx.Format = DXGI_FORMAT_R8G8B8A8_UNORM;
  descTx.SampleDesc.Count = 1;
  descTx.SampleDesc.Quality = 0;
  descTx.Usage = D3D11_USAGE_DEFAULT;
  descTx.BindFlags = D3D11_BIND_SHADER_RESOURCE;
  descTx.CPUAccessFlags = 0;
  descTx.MiscFlags = 0;
  // f[^̍쐬
  D3D11_SUBRESOURCE_DATA InitData;
  ZeroMemory( &InitData, sizeof(InitData) );
  InitData.pSysMem=new BYTE[tex_width*4*tex_height];
  InitData.SysMemPitch=tex_width*4;
  int nPitchSrc=((tex_width*3+3)/4)*4;
  for(int iy=0;iy<tex_height;iy++){
    BYTE *iSrc=pBmp+nPitchSrc*iy;
    BYTE *iDst=((BYTE *)(InitData.pSysMem))+InitData.SysMemPitch*iy;
    for(int ix=0;ix<tex_width;ix++){
      *iDst=(*(iSrc+2));
      *(iDst+1)=(*(iSrc+1));
      *(iDst+2)=(*iSrc);
      *(iDst+3)=255;
      iSrc+=3;
      iDst+=4;
    }
  }
  ID3D11Texture2D *pTexture = nullptr;
  HRESULT hr = S_OK;
  hr = g_pd3dDevice->CreateTexture2D(&descTx, &InitData, &pTexture);
  hr = g_pd3dDevice->CreateShaderResourceView(pTexture, nullptr,
                                              pShaderResourceView);
  if(pTexture) pTexture->Release();
  delete[] InitData.pSysMem;
}

// `掑̉
void ReleaseResForDrawing(HBITMAP hBmp, HDC hBmpDC, HBITMAP hBmpOld){
  // Rp`uDC̉
  SelectObject(hBmpDC, hBmpOld);
  DeleteDC(hBmpDC);
  // DIBSection̉
  DeleteObject(hBmp);
}

// vplɌݎ`
void DrawClockNowTime(){
  if(g_ClockPanel.pShaderResourceView) g_ClockPanel.pShaderResourceView->Release();
  g_ClockPanel.pShaderResourceView=nullptr;
  // `揀
  unsigned char *pBmp=nullptr;
  HBITMAP hBmp=NULL;
  HDC hBmpDC=NULL;
  HBITMAP hBmpOld=NULL;
  PrepareBitmapDrawing(&pBmp, &hBmp, &hBmpDC, &hBmpOld,
                       g_ClockPanel.width, g_ClockPanel.height);
  // pl摜`
  RECT rc;
  rc.left=0;
  rc.top=0;
  rc.right=g_ClockPanel.width;
  rc.bottom=g_ClockPanel.height;
  FillRect(hBmpDC, &rc, (HBRUSH)GetStockObject(WHITE_BRUSH));
  HFONT hFont=CreateFont(20,0,0,0,FW_BOLD,FALSE,FALSE,FALSE,SHIFTJIS_CHARSET,
                         0,0,0,0,L"lr oSVbN");
  HFONT hFontOld=(HFONT)SelectObject(hBmpDC,hFont);
  SetBkMode(hBmpDC, TRANSPARENT);
  SetTextColor(hBmpDC,RGB(0,255,255));
  TextOutA(hBmpDC, 5, 5, g_StrClockTime, strlen(g_StrClockTime));
  DrawFrame(hBmpDC,g_ClockPanel.width,g_ClockPanel.height,0,255,255);
  SelectObject(hBmpDC,hFontOld);
  DeleteObject(hFont);
  CreateSRVFromBitmap(&(g_ClockPanel.pShaderResourceView), pBmp,
                      g_ClockPanel.width, g_ClockPanel.height);
  // `p̉
  ReleaseResForDrawing(hBmp, hBmpDC, hBmpOld);
}

void UpdateClockPanel(){
  SYSTEMTIME st;
  char str[30];
  GetLocalTime(&st);
  sprintf(str, "%02d:%02d:%02d", st.wHour, st.wMinute, st.wSecond);
  if(strcmp(g_StrClockTime,str)!=0){
    strcpy(g_StrClockTime,str);
    DrawClockNowTime();
  }
}

// vpl̃ZbgAbv
void SetupClock(){
  g_ClockPanel.width=90;
  g_ClockPanel.height=30;
  float px=(-0.8f);
  float py=1.6f;
  XMStoreFloat4x4(&(g_ClockPanel.mWorld),
                  XMMatrixScaling(((float)g_ClockPanel.width)*UI_PANEL_SCALE,
                                  ((float)g_ClockPanel.height)*UI_PANEL_SCALE,0.3f)*
                  XMMatrixTranslation(px,py,2.5f));
  g_ClockPanel.state=0;
  g_ClockPanel.pShaderResourceView=nullptr;
  strcpy(g_StrClockTime,"");
  UpdateClockPanel();
}

// fobOpl̃ZbgAbv
void SetupDebugPanel(){
  g_DebugPanel.pShaderResourceView=nullptr;
  g_ClockPanel.state=0;
}

// pl̃ZbgAbv
void SetupUIPanels(){
  HRESULT hr = S_OK;
  int tex_width=512,tex_height=512;

  // UIplp_obt@
  SimpleVertex vertices[] ={
    { XMFLOAT3(-1.0f, -1.0f, 0.0f), XMFLOAT3(0.0f, 0.0f, -1.0f), XMFLOAT2(0.0f, 1.0f) },
    { XMFLOAT3( 1.0f, -1.0f, 0.0f), XMFLOAT3(0.0f, 0.0f, -1.0f), XMFLOAT2(1.0f, 1.0f) },
    { XMFLOAT3( 1.0f,  1.0f, 0.0f), XMFLOAT3(0.0f, 0.0f, -1.0f), XMFLOAT2(1.0f, 0.0f) },
    { XMFLOAT3(-1.0f,  1.0f, 0.0f), XMFLOAT3(0.0f, 0.0f, -1.0f), XMFLOAT2(0.0f, 0.0f) },
  };
  D3D11_BUFFER_DESC bd;
  ZeroMemory( &bd, sizeof(bd) );
  bd.Usage = D3D11_USAGE_DEFAULT;
  bd.ByteWidth = sizeof( SimpleVertex ) * 4;
  bd.BindFlags = D3D11_BIND_VERTEX_BUFFER;
  bd.CPUAccessFlags = 0;
  D3D11_SUBRESOURCE_DATA InitData;
  ZeroMemory( &InitData, sizeof(InitData) );
  InitData.pSysMem = vertices;
  hr = g_pd3dDevice->CreateBuffer( &bd, &InitData, &g_pVertexBufferUIPanel );

  // UIplpCfbNXobt@
  WORD indices[] ={
    2,1,0,
    0,3,2,
  };
  bd.Usage = D3D11_USAGE_DEFAULT;
  bd.ByteWidth = sizeof( WORD ) * 6;
  bd.BindFlags = D3D11_BIND_INDEX_BUFFER;
  bd.CPUAccessFlags = 0;
  InitData.pSysMem = indices;
  hr = g_pd3dDevice->CreateBuffer( &bd, &InitData, &g_pIndexBufferUIPanel );

  // eNX`
  for(int iPanel=0;iPanel<NUM_OF_UI_PANELS;iPanel++){
    tex_height=30;
    switch(iPanel){
    case 0:
      tex_width=150;
      break;
    case 1:
    case 2:
    case 3:
    case 4:
    case 5:
    case 6:
    case 7:
      tex_width=30;
      break;
    case 8:
    case 9:
      tex_width=50;
      break;
    case 10:
    case 11:
      tex_width=90;
      break;
    case 12:
    case 13:
    case 14:
    case 15:
      tex_width=50;
      break;
    case 16:
    case 17:
    case 18:
      tex_width=70;
      break;
    }
    g_aUIPanels[iPanel].width=tex_width;
    g_aUIPanels[iPanel].height=tex_height;
    // `揀
    unsigned char *pBmp=nullptr;
    HBITMAP hBmp=NULL;
    HDC hBmpDC=NULL;
    HBITMAP hBmpOld=NULL;
    PrepareBitmapDrawing(&pBmp, &hBmp, &hBmpDC, &hBmpOld, tex_width, tex_height);
    // pl摜`
    RECT rc;
    rc.left=0;
    rc.top=0;
    rc.right=tex_width;
    rc.bottom=tex_height;
    FillRect(hBmpDC, &rc, (HBRUSH)GetStockObject(WHITE_BRUSH));
    HFONT hFont=CreateFont(20,0,0,0,FW_BOLD,FALSE,FALSE,FALSE,SHIFTJIS_CHARSET,
                           0,0,0,0,L"lr oSVbN");
    HFONT hFontOld=(HFONT)SelectObject(hBmpDC,hFont);
    SetBkMode(hBmpDC, TRANSPARENT);
    if(iPanel==0){
      SetTextColor(hBmpDC,RGB(0,255,0));
      char *str1="pl\";
      TextOutA(hBmpDC, 5, 5, str1, strlen(str1));
      DrawFrame(hBmpDC,tex_width,tex_height,0,255,0);
    }
    else if(iPanel==1){
      SetTextColor(hBmpDC,RGB(255,0,0));
      char *str1="";
      TextOutA(hBmpDC, 5, 5, str1, strlen(str1));
      DrawFrame(hBmpDC,tex_width,tex_height,255,0,0);
    }
    else if(iPanel==2){
      SetTextColor(hBmpDC,RGB(0,0,0));
      char *str1="";
      TextOutA(hBmpDC, 5, 5, str1, strlen(str1));
      DrawFrame(hBmpDC,tex_width,tex_height,0,0,0);
    }
    else if(iPanel==3){
      SetTextColor(hBmpDC,RGB(0,0,0));
      char *str1="";
      TextOutA(hBmpDC, 5, 5, str1, strlen(str1));
      DrawFrame(hBmpDC,tex_width,tex_height,0,0,0);
    }
    else if(iPanel==4){
      SetTextColor(hBmpDC,RGB(0,0,0));
      char *str1="E";
      TextOutA(hBmpDC, 5, 5, str1, strlen(str1));
      DrawFrame(hBmpDC,tex_width,tex_height,0,0,0);
    }
    else if(iPanel==5){
      SetTextColor(hBmpDC,RGB(0,0,0));
      char *str1="O";
      TextOutA(hBmpDC, 5, 5, str1, strlen(str1));
      DrawFrame(hBmpDC,tex_width,tex_height,0,0,0);
    }
    else if(iPanel==6){
      SetTextColor(hBmpDC,RGB(0,0,255));
      char *str1="";
      TextOutA(hBmpDC, 5, 5, str1, strlen(str1));
      DrawFrame(hBmpDC,tex_width,tex_height,0,0,255);
    }
    else if(iPanel==7){
      SetTextColor(hBmpDC,RGB(0,0,255));
      char *str1="";
      TextOutA(hBmpDC, 5, 5, str1, strlen(str1));
      DrawFrame(hBmpDC,tex_width,tex_height,0,0,255);
    }
    else if(iPanel==8){
      SetTextColor(hBmpDC,RGB(255,0,255));
      char *str1="";
      TextOutA(hBmpDC, 5, 5, str1, strlen(str1));
      DrawFrame(hBmpDC,tex_width,tex_height,255,0,255);
    }
    else if(iPanel==9){
      SetTextColor(hBmpDC,RGB(255,0,255));
      char *str1="E";
      TextOutA(hBmpDC, 5, 5, str1, strlen(str1));
      DrawFrame(hBmpDC,tex_width,tex_height,255,0,255);
    }
    else if(iPanel==10){
      SetTextColor(hBmpDC,RGB(0,255,0));
      char *str1="ݔ";
      TextOutA(hBmpDC, 5, 5, str1, strlen(str1));
      DrawFrame(hBmpDC,tex_width,tex_height,0,255,0);
    }
    else if(iPanel==11){
      SetTextColor(hBmpDC,RGB(0,255,0));
      char *str1="ړ";
      TextOutA(hBmpDC, 5, 5, str1, strlen(str1));
      DrawFrame(hBmpDC,tex_width,tex_height,0,255,0);
    }
    else if(iPanel==12){
      SetTextColor(hBmpDC,RGB(255,0,255));
      char *str1="J";
      TextOutA(hBmpDC, 5, 5, str1, strlen(str1));
      DrawFrame(hBmpDC,tex_width,tex_height,255,0,255);
    }
    else if(iPanel==13){
      SetTextColor(hBmpDC,RGB(255,0,255));
      char *str1="";
      TextOutA(hBmpDC, 5, 5, str1, strlen(str1));
      DrawFrame(hBmpDC,tex_width,tex_height,255,0,255);
    }
    else if(iPanel==14){
      SetTextColor(hBmpDC,RGB(0,0,255));
      char *str1="O";
      TextOutA(hBmpDC, 5, 5, str1, strlen(str1));
      DrawFrame(hBmpDC,tex_width,tex_height,0,0,255);
    }
    else if(iPanel==15){
      SetTextColor(hBmpDC,RGB(0,0,255));
      char *str1="";
      TextOutA(hBmpDC, 5, 5, str1, strlen(str1));
      DrawFrame(hBmpDC,tex_width,tex_height,0,0,255);
    }
    else if(iPanel==16){
      SetTextColor(hBmpDC,RGB(255,0,0));
      char *str1="@";
      TextOutA(hBmpDC, 5, 5, str1, strlen(str1));
      DrawFrame(hBmpDC,tex_width,tex_height,255,0,0);
    }
    else if(iPanel==17){
      SetTextColor(hBmpDC,RGB(255,0,0));
      char *str1="@";
      TextOutA(hBmpDC, 5, 5, str1, strlen(str1));
      DrawFrame(hBmpDC,tex_width,tex_height,255,0,0);
    }
    else if(iPanel==18){
      SetTextColor(hBmpDC,RGB(255,0,255));
      char *str1="L^";
      TextOutA(hBmpDC, 5, 5, str1, strlen(str1));
      DrawFrame(hBmpDC,tex_width,tex_height,255,0,255);
    }
    SelectObject(hBmpDC,hFontOld);
    DeleteObject(hFont);
    CreateSRVFromBitmap(&(g_aUIPanels[iPanel].pShaderResourceView), pBmp, tex_width, tex_height);
    g_aUIPanels[iPanel].state=0;
    // `p̉
    ReleaseResForDrawing(hBmp, hBmpDC, hBmpOld);
  }
  SetupClock();
  SetupDebugPanel();
}

int UIPActCondition(XMVECTOR vViewDir,XMVECTOR vEyePos,LMCHand *wkLMCHand,XMMATRIX *mWorldLMC){
  int rtn=1;
  float wx,wz;

  if(!(wkLMCHand->validLeftRight)) rtn=0;
  else{
    for(int iFinger=0;iFinger<5;iFinger++){
      XMMATRIX mHand=XMLoadFloat4x4(&(wkLMCHand->mWorld));
      XMVECTOR vWork=XMVectorSet(wkLMCHand->mWJoint[iFinger][2].m[2][0],
                                 wkLMCHand->mWJoint[iFinger][2].m[2][1],
                                 wkLMCHand->mWJoint[iFinger][2].m[2][2],0.0f);
      if(iFinger==0){ // ewȂR֐߂ZEȂɉEAȂ獶
        wx=XMVectorGetX(XMVector3Dot(vWork,mHand.r[0]));
        if(wkLMCHand->LeftRight>0.0f){
          if(wx<0.0f) rtn=0;
        } else{
          if(wx>0.0f) rtn=0;
        }
      } else{
        wz=XMVectorGetX(XMVector3Dot(vWork,mHand.r[2]));
        if(iFinger==1){ // lwȂAR֐߂ZɑO
          if(wz<=0.0f) rtn=0;
        } else{ // ̎wȂAR֐߂Z
          if(wz>=0.0f) rtn=0;
        }
      }
    }
  }
  if(rtn){
    // ẅʒu߂
    XMVECTOR vFingerPos=GetLMCFingerPos(wkLMCHand,mWorldLMC,1);
    // Ƃ̔r
    XMVECTOR vFingerDir=vFingerPos-vEyePos;
    float fVDLength=XMVectorGetX(XMVector3Length(vViewDir));
    float fFDLength=XMVectorGetX(XMVector3Length(vFingerDir));
    if((fabs(fVDLength)>0.001f)&&(fabs(fFDLength)>0.001f)){
      float similarity=XMVectorGetX(XMVector3Dot(vViewDir,vFingerDir))/fVDLength/fFDLength;
      if(similarity<0.9f) rtn=0;
    } else rtn=0;
  }
  return rtn;
}

int UIPanelPushed(int iPanel,XMMATRIX *mBase,LMCHand *wkLMCHand,XMMATRIX *mWorldLMC){
  int rtn=0;
  XMVECTOR vDet;
  XMMATRIX mWorkPanelInv=
    XMMatrixInverse(&vDet,XMLoadFloat4x4(&(g_aUIPanels[iPanel].mWorld))*(*mBase));
  XMVECTOR vFingerPos=GetLMCFingerPos(wkLMCHand,mWorldLMC,1);
  vFingerPos=XMVector3Transform(vFingerPos,mWorkPanelInv);
  if((fabs(XMVectorGetX(vFingerPos))<=1.0f)&&(fabs(XMVectorGetY(vFingerPos))<=1.0f)&&
     (XMVectorGetZ(vFingerPos)>=0.0f)&&(XMVectorGetZ(vFingerPos)<=1.0f))
    rtn=1;
  return rtn;
}

int UIPanelPushedByMouse(int iPanel){
  int rtn=0;
  if(g_ui_mouse_down){
    XMVECTOR vDet;
    XMMATRIX mWorkPanelInv=
      XMMatrixInverse(&vDet,XMLoadFloat4x4(&(g_aUIPanels[iPanel].mWorld)));
    XMVECTOR vMousePos=XMVectorSet(g_VRMousePos_x,g_VRMousePos_y,0.0f,0.0f);
    vMousePos=XMVector3Transform(vMousePos,mWorkPanelInv);
    if((fabs(XMVectorGetX(vMousePos))<=1.0f)&&(fabs(XMVectorGetY(vMousePos))<=1.0f))
      rtn=1;
  }
  return rtn;
}

void LayoutUIPanels(){
  for(int iPanel=1;iPanel<NUM_OF_UI_PANELS;iPanel++){
    g_aUIPanels[iPanel].state=0;
    float px,py;
    if(g_UIPanelPage==0){
      switch(iPanel){
      case 1:
        px=1.3f;
        py=1.0f;
        break;
      case 2:
        px=(-1.0f);
        py=(-0.6f);
        break;
      case 3:
        px=(-0.4f);
        py=(-0.6f);
        break;
      case 4:
        px=0.2f;
        py=(-0.6f);
        break;
      case 5:
        px=(-0.4f);
        py=0.0f;
        break;
      case 6:
        px=1.3f;
        py=0.0f;
        break;
      case 7:
        px=1.3f;
        py=(-0.6f);
        break;
      case 8:
        px=(-1.2f);
        py=0.0f;
        break;
      case 9:
        px=0.4f;
        py=0.0f;
        break;
      case 10:
        px=0.0f;
        py=(-1.5f);
        break;
      default:
        g_aUIPanels[iPanel].state=2;
      }
    } else{
      switch(iPanel){
      case 1:
        px=1.3f;
        py=1.0f;
        break;
      case 11:
        px=0.0f;
        py=(-1.5f);
        break;
      case 12:
        px=0.3f;
        py=0.0f;
        break;
      case 13:
        px=0.3f;
        py=(-0.6f);
        break;
      case 14:
        px=1.3f;
        py=0.0f;
        break;
      case 15:
        px=1.3f;
        py=(-0.6f);
        break;
      case 16:
        px=(-1.0f);
        py=0.0f;
        break;
      case 17:
        px=(-1.0f);
        py=(-0.6f);
        break;
      case 18:
        px=(-1.0f);
        py=1.0f;
        break;
      default:
        g_aUIPanels[iPanel].state=2;
      }
    }
    if(g_aUIPanels[iPanel].state!=2){
      XMStoreFloat4x4(&(g_aUIPanels[iPanel].mWorld),
                      XMMatrixScaling(((float)g_aUIPanels[iPanel].width)*UI_PANEL_SCALE,
                                      ((float)g_aUIPanels[iPanel].height)*UI_PANEL_SCALE,0.3f)*
                      XMMatrixTranslation(px,py,2.5f));
    }
  }
}

void GetUIBaseMatrix(XMMATRIX *mUIBase,XMMATRIX *nowRollPitchYawPos,XMMATRIX *mEyeBase){
  mUIBase->r[0]=mEyeBase->r[0];
  mUIBase->r[1]=mEyeBase->r[1];
  mUIBase->r[2]=mEyeBase->r[2];
  mUIBase->r[3]=nowRollPitchYawPos->r[3];
}

void OperateUIPanels(XMMATRIX *nowRollPitchYawPos,XMMATRIX *mEyeBase,LMCHand *listLMCHand,
                     XMMATRIX *mWorldLMC,float dt){
  XMMATRIX mUIBase;
  GetUIBaseMatrix(&mUIBase,nowRollPitchYawPos,mEyeBase);
  XMVECTOR vViewDir=nowRollPitchYawPos->r[2];
  if(g_VRMouseVisibleTime>0.0f) g_VRMouseVisibleTime-=dt;
  if(g_aUIPanels[0].state==0){ // 
    for(g_pActLMCHand=listLMCHand;g_pActLMCHand;g_pActLMCHand=g_pActLMCHand->next){
      if(UIPActCondition(vViewDir,nowRollPitchYawPos->r[3],g_pActLMCHand,mWorldLMC)) break;
    }
    if(g_pActLMCHand){
      g_UIPanelStTime=0.0f;
      g_aUIPanels[0].state=1;
    }
  } else if(g_aUIPanels[0].state==1){ // pl\{^o҂
    LMCHand *wkLMCHand;
    for(wkLMCHand=listLMCHand;wkLMCHand;wkLMCHand=wkLMCHand->next){
      if(wkLMCHand==g_pActLMCHand) break;
    }
    if(wkLMCHand && UIPActCondition(vViewDir,nowRollPitchYawPos->r[3],g_pActLMCHand,mWorldLMC)){
      g_UIPanelStTime+=dt;
      if(g_UIPanelStTime>1.0f){
        XMVECTOR vFingerPos=GetLMCFingerPos(g_pActLMCHand,mWorldLMC,1);
        XMMATRIX mEyeBaseRot=(*mEyeBase);
        mEyeBaseRot.r[3]=XMVectorSet(0.0f,0.0f,0.0f,1.0f);
        XMVECTOR vWk1=vFingerPos+XMVector3Transform(XMVectorSet(0.0f,0.0f,0.5f,0.0f),mEyeBaseRot);
        XMVECTOR vDet;
        XMMATRIX mEyeBaseInv=XMMatrixInverse(&vDet,*mEyeBase);
        vWk1=XMVector3Transform(vWk1,mEyeBaseInv);
        XMStoreFloat4x4(&(g_aUIPanels[0].mWorld),
                        XMMatrixScaling(((float)g_aUIPanels[0].width)*UI_PANEL_SCALE,
                                        ((float)g_aUIPanels[0].height)*UI_PANEL_SCALE,0.3f)*
                        XMMatrixTranslationFromVector(vWk1));
        g_aUIPanels[0].state=2;
      }
    } else g_aUIPanels[0].state=0;
  } else if(g_aUIPanels[0].state==2){ // pl\{^҂
    LMCHand *wkLMCHand;
    for(wkLMCHand=listLMCHand;wkLMCHand;wkLMCHand=wkLMCHand->next){
      if(wkLMCHand==g_pActLMCHand) break;
    }
    if((!wkLMCHand)||(!UIPActCondition(vViewDir,nowRollPitchYawPos->r[3],g_pActLMCHand,mWorldLMC)))
      g_aUIPanels[0].state=0;
    else if(UIPanelPushed(0,mEyeBase,wkLMCHand,mWorldLMC)){
      g_aUIPanels[0].state=3;
      LayoutUIPanels();
    }
  } else if(g_aUIPanels[0].state==3){ // pl
    for(int iPanel=1;iPanel<NUM_OF_UI_PANELS;iPanel++){
      if(g_aUIPanels[iPanel].state!=2){ // YplL
        LMCHand *wkLMCHand=nullptr;
        for(wkLMCHand=listLMCHand;wkLMCHand;wkLMCHand=wkLMCHand->next){
          if(UIPanelPushed(iPanel,&mUIBase,wkLMCHand,mWorldLMC)) break;
        }
        if(wkLMCHand||UIPanelPushedByMouse(iPanel)){
          if(g_aUIPanels[iPanel].state==0){
            // plꂽ̓
            g_aUIPanels[iPanel].state=1;
            switch(iPanel){
            case 2:
              g_EyeVelocity.x=(-g_EyeSpeed);
              break;
            case 3:
              g_EyeVelocity.z=(-g_EyeSpeed);
              break;
            case 4:
              g_EyeVelocity.x=g_EyeSpeed;
              break;
            case 5:
              g_EyeVelocity.z=g_EyeSpeed;
              break;
            case 6:
              g_EyeVelocity.y=g_EyeSpeed;
              break;
            case 7:
              g_EyeVelocity.y=(-g_EyeSpeed);
              break;
            case 8:
              g_EyeBaseYawVelocity=(-g_EyeBaseYawSpeed);
              break;
            case 9:
              g_EyeBaseYawVelocity=g_EyeBaseYawSpeed;
              break;
            case 12:
              g_leg_open_v_angle=g_leg_s_open_front;
              break;
            case 13:
              g_leg_open_v_angle=(-g_leg_s_open_front); 
              break;
            case 14:
              g_leg_front_v_angle=g_leg_s_open_front;
              break;
            case 15:
              g_leg_front_v_angle=(-g_leg_s_open_front);
              break;
            case 16:
              g_tkl_hand_active[0]=(!g_tkl_hand_active[0]);
              g_tkl_hand_active[1]=(!g_tkl_hand_active[1]);
              break;
            case 17:
              g_tkl_hand_active[2]=(!g_tkl_hand_active[2]);
              g_tkl_hand_active[3]=(!g_tkl_hand_active[3]);
              break;
            case 18:
              if(IsRecordingVMD(&g_VmdWork)){
                StopVMDRec(&g_VmdWork);
                VMDSave(&g_VmdWork);
              } else{
                BeginMotionRecord(&g_VmdWork,&g_PmdxWork);
              }
              break;
            }
          }
        }
        else if(g_aUIPanels[iPanel].state==1){
          // ꂽpl߂鎞̓
          g_aUIPanels[iPanel].state=0;
          switch(iPanel){
          case 1:
            g_aUIPanels[0].state=0;
            break;
          case 2:
          case 4:
            g_EyeVelocity.x=0.0f;
            break;
          case 3:
          case 5:
            g_EyeVelocity.z=0.0f;
            break;
          case 6:
          case 7:
            g_EyeVelocity.y=0.0f;
            break;
          case 8:
          case 9:
            g_EyeBaseYawVelocity=0.0f;
            break;
          case 10:
            g_UIPanelPage=1;
            LayoutUIPanels();
            break;
          case 11:
            g_UIPanelPage=0;
            LayoutUIPanels();
            break;
          case 12:
          case 13:
            g_leg_open_v_angle=0.0f;
            break;
          case 14:
          case 15:
            g_leg_front_v_angle=0.0f;
            break;
          }
        }
      }
    }
  }
  UpdateClockPanel();
}

// pl`
void RenderUIPanels(ConstantBuffer &cb1,XMMATRIX *nowRollPitchYawPos,XMMATRIX *mEyeBase){
  XMMATRIX mUIBase;
  GetUIBaseMatrix(&mUIBase,nowRollPitchYawPos,mEyeBase);
  // Set vertex buffer
  UINT stride = sizeof( SimpleVertex );
  UINT offset = 0;
  g_pImmediateContext->IASetVertexBuffers( 0, 1, &g_pVertexBufferUIPanel, &stride, &offset );
  // Set index buffer
  g_pImmediateContext->IASetIndexBuffer( g_pIndexBufferUIPanel, DXGI_FORMAT_R16_UINT, 0 );
  //Жʕ`
  g_pImmediateContext->RSSetState(g_pRasterizerStateSingleSide);
  // fobOpl
  if(g_DebugPanel.state!=0){
    // ގ̐ݒ
    cb1.TexStrength=1.0f;
    cb1.SphStrength=0.0f;
    cb1.SpaStrength=0.0f;
    cb1.ACol=XMFLOAT3(1.0f, 1.0f, 1.0f);
    cb1.SCol=XMFLOAT3(0.0f, 0.0f, 0.0f);
    cb1.SPower=1.0;
    cb1.DCol=XMFLOAT4(1.f, 1.0f, 1.0f, 0.5f);
    cb1.mWorld=XMMatrixTranspose(XMLoadFloat4x4(&(g_DebugPanel.mWorld))*mUIBase);
    g_pImmediateContext->UpdateSubresource( g_pConstantBuffer, 0, nullptr, &cb1, 0, 0 );
    g_pImmediateContext->PSSetShaderResources(0, 1, &(g_DebugPanel.pShaderResourceView));
    g_pImmediateContext->DrawIndexed( 6, 0, 0 );
  }
  // ގ̐ݒ
  cb1.TexStrength=1.0f;
  cb1.SphStrength=0.0f;
  cb1.SpaStrength=0.0f;
  cb1.ACol=XMFLOAT3(1.0f, 1.0f, 1.0f);
  cb1.SCol=XMFLOAT3(0.0f, 0.0f, 0.0f);
  cb1.SPower=1.0;
  for(int iPanel=0;iPanel<NUM_OF_UI_PANELS;iPanel++){
    if((g_aUIPanels[0].state==2)&&(iPanel==0)){
      cb1.DCol=XMFLOAT4(1.f, 1.0f, 1.0f, 1.f);
      cb1.mWorld=XMMatrixTranspose(XMLoadFloat4x4(&(g_aUIPanels[iPanel].mWorld))*(*mEyeBase));
      g_pImmediateContext->UpdateSubresource( g_pConstantBuffer, 0, nullptr, &cb1, 0, 0 );
      g_pImmediateContext->PSSetShaderResources(0, 1, &(g_aUIPanels[iPanel].pShaderResourceView));
      g_pImmediateContext->DrawIndexed( 6, 0, 0 );
    } else if((g_aUIPanels[0].state==3)&&(iPanel>0)){
      if(g_aUIPanels[iPanel].state!=2){
        int flgOn=0;
        if(iPanel==16){
          if(g_tkl_hand_active[0]) flgOn=1;
        } else if(iPanel==17){
          if(g_tkl_hand_active[2]) flgOn=1;
        } else if(iPanel==18){
          if(IsRecordingVMD(&g_VmdWork)) flgOn=1;
        } else{
          if(g_aUIPanels[iPanel].state==1) flgOn=1;
        }
        if(flgOn) cb1.DCol=XMFLOAT4(1.f, 1.0f, 1.0f, 1.0f);
        else cb1.DCol=XMFLOAT4(1.f, 1.0f, 1.0f, 0.5f);
        cb1.mWorld=XMMatrixTranspose(XMLoadFloat4x4(&(g_aUIPanels[iPanel].mWorld))*mUIBase);
        g_pImmediateContext->UpdateSubresource( g_pConstantBuffer, 0, nullptr, &cb1, 0, 0 );
        g_pImmediateContext->PSSetShaderResources(0, 1, &(g_aUIPanels[iPanel].pShaderResourceView));
        g_pImmediateContext->DrawIndexed( 6, 0, 0 );
      }
    }
  }
  // v
  if(g_aUIPanels[0].state==3){
    cb1.DCol=XMFLOAT4(1.f, 1.0f, 1.0f, 0.5f);
    cb1.mWorld=XMMatrixTranspose(XMLoadFloat4x4(&(g_ClockPanel.mWorld))*mUIBase);
    g_pImmediateContext->UpdateSubresource( g_pConstantBuffer, 0, nullptr, &cb1, 0, 0 );
    g_pImmediateContext->PSSetShaderResources(0, 1, &(g_ClockPanel.pShaderResourceView));
    g_pImmediateContext->DrawIndexed( 6, 0, 0 );
  }
  // }EXJ[\
  if((g_VRMouseVisibleTime>0.0f)&&(g_aUIPanels[0].state==3)){
    // ގ̐ݒ
    cb1.TexStrength=0.0f;
    cb1.SphStrength=0.0f;
    cb1.SpaStrength=0.0f;
    cb1.ACol=XMFLOAT3(1.0f, 0.5f, 0.0f);
    cb1.SCol=XMFLOAT3(0.0f, 0.0f, 0.0f);
    cb1.SPower=0.0;
    cb1.DCol=XMFLOAT4(1.0f, 0.5f, 0.0f, 0.7f);
    cb1.mWorld=XMMatrixTranspose(XMMatrixScaling(0.1f,0.1f,0.1f)*
                                 XMMatrixTranslation(g_VRMousePos_x,g_VRMousePos_y,2.499f)*
                                 mUIBase);
    g_pImmediateContext->UpdateSubresource( g_pConstantBuffer, 0, nullptr, &cb1, 0, 0 );
    g_pImmediateContext->DrawIndexed( 6, 0, 0 );
  }
}

// vpl̃NA
void CleanupClockPanel(){
  if(g_ClockPanel.pShaderResourceView) g_ClockPanel.pShaderResourceView->Release();
}

// fobOplNA
void CleanupDebugPanel(){
  if(g_DebugPanel.pShaderResourceView) g_DebugPanel.pShaderResourceView->Release();
}

// pl̃NA
void CleanupUIPanels(){
  for(int iPanel=0;iPanel<NUM_OF_UI_PANELS;iPanel++){
    if(g_aUIPanels[iPanel].pShaderResourceView) g_aUIPanels[iPanel].pShaderResourceView->Release();
  }
  CleanupClockPanel(); // v
  if(g_pIndexBufferUIPanel) g_pIndexBufferUIPanel->Release();
  if(g_pVertexBufferUIPanel) g_pVertexBufferUIPanel->Release();
  CleanupDebugPanel();
}

// VMDL^̊Jn
void BeginMotionRecord(t_VmdWork *pVmdWork,t_PmdxWork *pPmdxWork){
  char *aBoneName[]={
    "","","㔼g","㔼g2",
    "","r","Ђ","","Ђ","",
    "E","Er","EЂ","E","EЂ","E",
    "","g"
  };
  int nBoneName=sizeof(aBoneName)/sizeof(char *);
  char *aMorphName[]={
    "܂΂","͂","΂","EBN","ECN","","","","","{"
  };
  int nMorphName=sizeof(aMorphName)/sizeof(char *);
  char *aBLocRootName[]={"","g"};
  int nBLocRootName=sizeof(aBLocRootName)/sizeof(char *);
  StartVMDRec(pVmdWork,pPmdxWork,aBoneName,nBoneName,aBLocRootName,nBLocRootName,
              aMorphName,nMorphName);
}

// fobOpl\
void ShowDebugPanel(int numMsgShow, const char *msgShow[], float width){
  g_DebugPanel.width=width;
  g_DebugPanel.height=numMsgShow*20+10;
  float px=0.0f;
  float py=0.0f;
  XMStoreFloat4x4(&(g_DebugPanel.mWorld),
                  XMMatrixScaling(((float)g_DebugPanel.width)*UI_PANEL_SCALE,
                                  ((float)g_DebugPanel.height)*UI_PANEL_SCALE,0.3f)*
                  XMMatrixTranslation(px,py,5.0f));
  g_DebugPanel.state=1;
  if(g_DebugPanel.pShaderResourceView) g_DebugPanel.pShaderResourceView->Release();
  g_DebugPanel.pShaderResourceView=nullptr;
  // `揀
  unsigned char *pBmp=nullptr;
  HBITMAP hBmp=NULL;
  HDC hBmpDC=NULL;
  HBITMAP hBmpOld=NULL;
  PrepareBitmapDrawing(&pBmp, &hBmp, &hBmpDC, &hBmpOld,
                       g_DebugPanel.width, g_DebugPanel.height);
  // pl摜`
  RECT rc;
  rc.left=0;
  rc.top=0;
  rc.right=g_DebugPanel.width;
  rc.bottom=g_DebugPanel.height;
  FillRect(hBmpDC, &rc, (HBRUSH)GetStockObject(WHITE_BRUSH));
  HFONT hFont=CreateFont(20,0,0,0,FW_BOLD,FALSE,FALSE,FALSE,SHIFTJIS_CHARSET,
                         0,0,0,0,L"lr oSVbN");
  HFONT hFontOld=(HFONT)SelectObject(hBmpDC,hFont);
  SetBkMode(hBmpDC, TRANSPARENT);
  SetTextColor(hBmpDC,RGB(0, 0, 0));
  for(int i=0;i<numMsgShow;i++){
    TextOutA(hBmpDC, 5, i*20+5, msgShow[i], strlen(msgShow[i]));
  }
  DrawFrame(hBmpDC,g_DebugPanel.width,g_DebugPanel.height,0,0,0);
  SelectObject(hBmpDC,hFontOld);
  DeleteObject(hFont);
  CreateSRVFromBitmap(&(g_DebugPanel.pShaderResourceView), pBmp,
                      g_DebugPanel.width, g_DebugPanel.height);
  // `p̉
  ReleaseResForDrawing(hBmp, hBmpDC, hBmpOld);
}

// fobOpl\
void HideDebugPanel(){
  g_DebugPanel.state=0;
}
