// VMDf[^L^Eo
//(QlFhttp://blog.goo.ne.jp/torisu_tetosuki/e/209ad341d3ece2b1b4df24abf619d6e4)

#include <Windows.h>
#include <stdio.h>
#include "vmd.h"

void vmd_init(t_vmd_data *vmd_data){
  vmd_data->vmd_motion_count=0;
  vmd_data->vmd_motion=nullptr;
  vmd_data->vmd_skin_count=0;
  vmd_data->vmd_skin=nullptr;
  vmd_data->vmd_camera_count=0;
  vmd_data->vmd_camera=nullptr;
  vmd_data->vmd_light_count=0;
  vmd_data->vmd_light=nullptr;
  vmd_data->vmd_self_shadow_count=0;
  vmd_data->vmd_self_shadow=nullptr;
  vmd_data->vmd_visible_ik_data_count=0;
  vmd_data->vmd_visible_ik_data=nullptr;

  vmd_data->vmd_motion_capacity=0;
  vmd_data->vmd_skin_capacity=0;
  vmd_data->vmd_camera_capacity=0;
  vmd_data->vmd_light_capacity=0;
  vmd_data->vmd_self_shadow_capacity=0;
  vmd_data->vmd_visible_ik_data_capacity=0;
}

void vmd_reset_to_rec(t_vmd_data *vmd_data,
                      int n_motion,int n_skin, int n_camera, int n_light, int n_self_shadow,
                      int n_visible_ik_data){
  destroy_vmd_data(vmd_data);
  vmd_init(vmd_data);
  ZeroMemory(vmd_data->VmdHeader,sizeof(vmd_data->VmdHeader));
  strcpy(vmd_data->VmdHeader,"Vocaloid Motion Data 0002");
  ZeroMemory(vmd_data->VmdModelName,sizeof(vmd_data->VmdModelName));
  if(n_motion>0){
    vmd_data->vmd_motion=new t_vmd_motion[n_motion];
    vmd_data->vmd_motion_capacity=n_motion;
  }
  if(n_skin>0){
    vmd_data->vmd_skin=new t_vmd_skin[n_skin];
    vmd_data->vmd_skin_capacity=n_skin;
  }
  if(n_camera>0){
    vmd_data->vmd_camera=new t_vmd_camera[n_camera];
    vmd_data->vmd_camera_capacity=n_camera;
  }
  if(n_light>0){
    vmd_data->vmd_light=new t_vmd_light[n_light];
    vmd_data->vmd_light_capacity=n_light;
  }
  if(n_self_shadow>0){
    vmd_data->vmd_self_shadow=new t_vmd_self_shadow[n_self_shadow];
    vmd_data->vmd_self_shadow_capacity=n_self_shadow;
  }
  if(n_visible_ik_data>0){
    vmd_data->vmd_visible_ik_data=new t_vmd_visible_ik_data[n_visible_ik_data];
    vmd_data->vmd_visible_ik_data_capacity=n_visible_ik_data;
  }
}

void vmd_motion_rec(t_vmd_data *vmd_data,char *bone_name,int nfr,
                    float x,float y,float z,float qx,float qy,float qz,float qw,
                    int Xax,int Yax,int Zax,int Rax,int Xay,int Yay,int Zay,int Ray,
                    int Xbx,int Ybx,int Zbx,int Rbx,int Xby,int Yby,int Zby,int Rby){
  int i=vmd_data->vmd_motion_count;
  int namesize=sizeof(vmd_data->vmd_motion->BoneName);
  ZeroMemory(vmd_data->vmd_motion[i].BoneName,namesize);
  int namelen=strlen(bone_name);
  if(namelen>namesize) namelen=namesize;
  strncpy(vmd_data->vmd_motion[i].BoneName,bone_name,namelen);
  vmd_data->vmd_motion[i].FrameNo=nfr;
  vmd_data->vmd_motion[i].Location[0]=x;
  vmd_data->vmd_motion[i].Location[1]=y;
  vmd_data->vmd_motion[i].Location[2]=z;
  vmd_data->vmd_motion[i].Rotatation[0]=qx;
  vmd_data->vmd_motion[i].Rotatation[1]=qy;
  vmd_data->vmd_motion[i].Rotatation[2]=qz;
  vmd_data->vmd_motion[i].Rotatation[3]=qw;
  vmd_data->vmd_motion[i].Interpolation[0]=Xax;
  vmd_data->vmd_motion[i].Interpolation[1]=Yax;
  vmd_data->vmd_motion[i].Interpolation[2]=Zax;
  vmd_data->vmd_motion[i].Interpolation[3]=Rax;
  vmd_data->vmd_motion[i].Interpolation[4]=Xay;
  vmd_data->vmd_motion[i].Interpolation[5]=Yay;
  vmd_data->vmd_motion[i].Interpolation[6]=Zay;
  vmd_data->vmd_motion[i].Interpolation[7]=Ray;
  vmd_data->vmd_motion[i].Interpolation[8]=Xbx;
  vmd_data->vmd_motion[i].Interpolation[9]=Ybx;
  vmd_data->vmd_motion[i].Interpolation[10]=Zbx;
  vmd_data->vmd_motion[i].Interpolation[11]=Rbx;
  vmd_data->vmd_motion[i].Interpolation[12]=Xby;
  vmd_data->vmd_motion[i].Interpolation[13]=Yby;
  vmd_data->vmd_motion[i].Interpolation[14]=Zby;
  vmd_data->vmd_motion[i].Interpolation[15]=Rby;
  vmd_data->vmd_motion_count++;
}

void vmd_skin_rec(t_vmd_data *vmd_data,char *skin_name,int nfr,float rate){
  int i=vmd_data->vmd_skin_count;
  int namesize=sizeof(vmd_data->vmd_skin->SkinName);
  ZeroMemory(vmd_data->vmd_skin[i].SkinName,namesize);
  int namelen=strlen(skin_name);
  if(namelen>namesize) namelen=namesize;
  strncpy(vmd_data->vmd_skin[i].SkinName,skin_name,namelen);
  vmd_data->vmd_skin[i].FrameNo=nfr;
  vmd_data->vmd_skin[i].Weight=rate;
  vmd_data->vmd_skin_count++;
}
                    
void vmd_visible_ik_rec(t_vmd_data *vmd_data,int nfr,int visible,char **ik_names,int *ik_enableds,
                        int ik_count){
  int i=vmd_data->vmd_visible_ik_data_count;
  vmd_data->vmd_visible_ik_data[i].frameNo=nfr;
  vmd_data->vmd_visible_ik_data[i].visible=visible;
  vmd_data->vmd_visible_ik_data[i].ikCount=ik_count;
  vmd_data->vmd_visible_ik_data[i].ikData=new t_vmd_ik_data[ik_count];
  for(int j=0;j<ik_count;j++){
    int n_size=sizeof(vmd_data->vmd_visible_ik_data->ikData->ikBoneName);
    ZeroMemory(vmd_data->vmd_visible_ik_data[i].ikData[j].ikBoneName,n_size);
    int n_len=strlen(ik_names[j]);
    if(n_len>n_size) n_len=n_size;
    strncpy(vmd_data->vmd_visible_ik_data[i].ikData[j].ikBoneName,ik_names[j],n_len);
    vmd_data->vmd_visible_ik_data[i].ikData[j].ikEnabled=ik_enableds[j];
  }
  vmd_data->vmd_visible_ik_data_count++;
}

void write_vmd_data(t_vmd_data *vmd_data,char *pathname,char **rtn_err_str){
  // MikuMikuTickleł́AJAƖAZtVhẼf[^͏0
  FILE *outfile=nullptr;
  char *err_str=nullptr;
  int err_flg=0;
  if((outfile=fopen(pathname,"wb"))==nullptr){
    err_str="VMDt@CJ܂";
    err_flg=1;
  }
  else{
    // wb_
    fwrite(vmd_data->VmdHeader,sizeof(vmd_data->VmdHeader),1,outfile);
    fwrite(vmd_data->VmdModelName,sizeof(vmd_data->VmdModelName),1,outfile);
    // [V
    BYTE interop_pad[3]={1,0,0};
    fwrite(&(vmd_data->vmd_motion_count),sizeof(DWORD),1,outfile);
    for(int i=0;i<vmd_data->vmd_motion_count;i++){
      fwrite(vmd_data->vmd_motion[i].BoneName,sizeof(vmd_data->vmd_motion->BoneName),1,outfile);
      fwrite(&(vmd_data->vmd_motion[i].FrameNo),sizeof(DWORD),1,outfile);
      fwrite(&(vmd_data->vmd_motion[i].Location),sizeof(vmd_data->vmd_motion->Location),1,outfile);
      fwrite(&(vmd_data->vmd_motion[i].Rotatation),sizeof(vmd_data->vmd_motion->Rotatation),1,outfile);
      for(int j=0;j<4;j++){
        fwrite(vmd_data->vmd_motion[i].Interpolation+j,
               sizeof(vmd_data->vmd_motion->Interpolation)-j,1,outfile);
        if(j>0){
          fwrite(interop_pad,j,1,outfile);
        }
      }
    }
    // \
    fwrite(&(vmd_data->vmd_skin_count),sizeof(DWORD),1,outfile);
    for(int i=0;i<vmd_data->vmd_skin_count;i++){
      fwrite(vmd_data->vmd_skin[i].SkinName,sizeof(vmd_data->vmd_skin->SkinName),1,outfile);
      fwrite(&(vmd_data->vmd_skin[i].FrameNo),sizeof(DWORD),1,outfile);
      fwrite(&(vmd_data->vmd_skin[i].Weight),sizeof(float),1,outfile);
    }
    // J
    fwrite(&(vmd_data->vmd_camera_count),sizeof(DWORD),1,outfile);
    for(int i=0;i<vmd_data->vmd_camera_count;i++){
      fwrite(&(vmd_data->vmd_camera[i].FrameNo),sizeof(DWORD),1,outfile);
      fwrite(&(vmd_data->vmd_camera[i].Length),sizeof(float),1,outfile);
      fwrite(&(vmd_data->vmd_camera[i].Location),sizeof(vmd_data->vmd_camera->Location),1,outfile);
      fwrite(&(vmd_data->vmd_camera[i].Rotation),sizeof(vmd_data->vmd_camera->Rotation),1,outfile);
      fwrite(&(vmd_data->vmd_camera[i].Interpolation),
             sizeof(vmd_data->vmd_camera->Interpolation),1,outfile);
      fwrite(&(vmd_data->vmd_camera[i].ViewingAngle),sizeof(DWORD),1,outfile);
      fwrite(&(vmd_data->vmd_camera[i].Perspective),sizeof(BYTE),1,outfile);
    }
    // Ɩ
    fwrite(&(vmd_data->vmd_light_count),sizeof(DWORD),1,outfile);
    for(int i=0;i<vmd_data->vmd_light_count;i++){
      fwrite(&(vmd_data->vmd_light[i].FrameNo),sizeof(DWORD),1,outfile);
      fwrite(&(vmd_data->vmd_light[i].RGB),sizeof(vmd_data->vmd_light->RGB),1,outfile);
      fwrite(&(vmd_data->vmd_light[i].Location),sizeof(vmd_data->vmd_light->Location),1,outfile);
    }
    // ZtVhE
    fwrite(&(vmd_data->vmd_self_shadow_count),sizeof(DWORD),1,outfile);
    for(int i=0;i<vmd_data->vmd_self_shadow_count;i++){
      fwrite(&(vmd_data->vmd_self_shadow[i].FrameNo),sizeof(DWORD),1,outfile);
      fwrite(&(vmd_data->vmd_self_shadow[i].Mode),sizeof(BYTE),1,outfile);
      fwrite(&(vmd_data->vmd_self_shadow[i].Distance),sizeof(float),1,outfile);
    }
    // \EIKf[^
    fwrite(&(vmd_data->vmd_visible_ik_data_count),sizeof(int),1,outfile);
    for(int i=0;i<vmd_data->vmd_visible_ik_data_count;i++){
      fwrite(&(vmd_data->vmd_visible_ik_data[i].frameNo),sizeof(int),1,outfile);
      fwrite(&(vmd_data->vmd_visible_ik_data[i].visible),sizeof(unsigned char),1,outfile);
      fwrite(&(vmd_data->vmd_visible_ik_data[i].ikCount),sizeof(int),1,outfile);
      for(int j=0;j<vmd_data->vmd_visible_ik_data->ikCount;j++){
        fwrite(vmd_data->vmd_visible_ik_data[i].ikData[j].ikBoneName,
               sizeof(vmd_data->vmd_visible_ik_data->ikData->ikBoneName),1,outfile);
        fwrite(&(vmd_data->vmd_visible_ik_data[i].ikData[j].ikEnabled),
               sizeof(unsigned char),1,outfile);
      }
    }
    fclose(outfile);
  }
  *rtn_err_str=err_str;
}

void destroy_vmd_data(t_vmd_data *vmd_data){
  if(vmd_data!=nullptr){
    delete[] vmd_data->vmd_motion;
    delete[] vmd_data->vmd_skin;
    delete[] vmd_data->vmd_camera;
    delete[] vmd_data->vmd_light;
    delete[] vmd_data->vmd_self_shadow;
    for(int i=0;i<vmd_data->vmd_visible_ik_data_count;i++){
      delete[] vmd_data->vmd_visible_ik_data[i].ikData;
    }
    delete[] vmd_data->vmd_visible_ik_data;
  }
}
