-- Tv2

function writeMat(mat)
  local i
  for i=0, 3 do
    MMTF.WriteLuaLog(string.format("%f %f %f %f", mat[1+i], mat[5+i], mat[9+i], mat[13+i]))
  end
end

function deg2rad(deg)
  return deg*3.14159/180
end

function rad2deg(rad)
  return rad*180/3.14159
end

function init()
  MMTF.WriteLuaLog("e֐̎sʁF")
  MMTF.WriteLuaLog("")

  local mat1=MMTF.MatrixIdentity()
  MMTF.WriteLuaLog("mat1=Identity:")
  writeMat(mat1)
  MMTF.WriteLuaLog("")

  local mat2=MMTF.MatrixMul(MMTF.MatrixMul(MMTF.MatrixRotZ(deg2rad(10)),
    MMTF.MatrixRotY(deg2rad(20))), MMTF.MatrixRotX(deg2rad(30)))
  MMTF.WriteLuaLog("mat2=rz(10)*ry(20)*rx(30):")
  writeMat(mat2)
  MMTF.WriteLuaLog("")

  local det,mat3=MMTF.MatrixInv(mat2)
  MMTF.WriteLuaLog(string.format("det=%f",det))
  MMTF.WriteLuaLog("mat3=inv(mat2):")
  writeMat(mat3)
  MMTF.WriteLuaLog("")

  local mat4=MMTF.MatrixMul(mat2,mat3)
  MMTF.WriteLuaLog("mat4=mat2*mat3:")
  writeMat(mat4)
  MMTF.WriteLuaLog("")

  local degX, degY, degZ=MMTF.GetRXYZFromMatrix(mat2)
  degX=rad2deg(degX)
  degY=rad2deg(degY)
  degZ=rad2deg(degZ)
  MMTF.WriteLuaLog(string.format("mat2->degX=%f degY=%f degZ=%f",degX, degY, degZ))
  MMTF.WriteLuaLog("")

  local mat5=MMTF.MatrixScaling(2,3,4)
  MMTF.WriteLuaLog("mat5=s(2,3,4):")
  writeMat(mat5)
  MMTF.WriteLuaLog("")

  local mat6=MMTF.MatrixTranslation(2,3,4)
  MMTF.WriteLuaLog("mat6=t(2,3,4):")
  writeMat(mat6)
  MMTF.WriteLuaLog("")

  local mat6v=MMTF.MatrixTranslationFromVector({2,3,4})
  MMTF.WriteLuaLog("mat6v=t({2,3,4}):")
  writeMat(mat6v)
  MMTF.WriteLuaLog("")

  local vec1={1,2,3}
  local vec2=MMTF.ScaledVec(2,vec1)
  MMTF.WriteLuaLog(string.format("vec1:%f %f %f",vec1[1],vec1[2],vec1[3]))
  MMTF.WriteLuaLog(string.format("vec2:%f %f %f",vec2[1],vec2[2],vec2[3]))

  local vec3=MMTF.VecAdd(vec1, vec2)
  MMTF.WriteLuaLog(string.format("vec3=vec1+vec2:%f %f %f",vec3[1],vec3[2],vec3[3]))

  local vec4=MMTF.VecSub(vec1, vec2)
  MMTF.WriteLuaLog(string.format("vec4=vec1-vec2:%f %f %f",vec4[1],vec4[2],vec4[3]))

  local dot=MMTF.VecDot(vec1, vec2)
  MMTF.WriteLuaLog(string.format("dot(vec1,vec2):%f",dot))

  local vec5={1,0,0}
  local vec6={0,1,0}
  local vec7=MMTF.VecCross(vec5,vec6)
  MMTF.WriteLuaLog(string.format("vec7=cross((1,0,0),(0,1,0)):%f %f %f",vec7[1],vec7[2],vec7[3]))

  local length=MMTF.VecLength(vec1)
  MMTF.WriteLuaLog(string.format("length(vec1):%f",length))

  local vec8=MMTF.VecTransform(mat6,vec1)
  MMTF.WriteLuaLog(string.format("vec8=mat6*vec1:%f %f %f",vec8[1],vec8[2],vec8[3]))

  local idx
  local name
  idx = MMTF.GetTouchAreaIdxByName("waistL")
  name = MMTF.GetTouchAreaNameByIdx(idx)
  MMTF.WriteLuaLog(string.format("Area %d:%s", idx, name))

  MMTF.WriteLuaLog(string.format("NumOfTouchArea:%d", MMTF.GetNumOfTouchArea()))
  MMTF.WriteLuaLog(string.format("NumOfTklHand:%d", MMTF.GetNumOfTklHand()))

  idx= MMTF.GetTklHandIdxByName("footL")
  name= MMTF.GetTklHandNameByIdx(idx)
  MMTF.WriteLuaLog(string.format("Hand %d:%s", idx, name))

  MMTF.WriteLuaLog(string.format("NumOfBone: %d", MMTF.GetNumOfBone()))

  idx=MMTF.GetBoneIdxByName("Er")
  name=MMTF.GetBoneNameByIdx(idx)
  MMTF.WriteLuaLog(string.format("Bone %d:%s", idx, name))
  local vec9=MMTF.GetInitialBonePos(idx)
  MMTF.WriteLuaLog(string.format("InitialBonePos: %f %f %f", vec9[1], vec9[2], vec9[3]))
  MMTF.WriteLuaLog(string.format("ModelName: %s", MMTF.GetModelName()))
end

function OnFrame()
  if MMTF.IsTickled(-1) or MMTF.IsBreathing() then
    local tval=MMTF.GetTickleVal(-1)
    local ttm, tlv = MMTF.GetReactionTklTimeLv()
    local btm=MMTF.GetReactionBreathTime()
    MMTF.ShowDebugPanel(500, "debug", string.format("tval=%f ttm=%f tlv=%f btm=%f",tval, ttm, tlv, btm))
  else
    MMTF.HideDebugPanel()
  end
end

init()
